window.fc = window.fc || {};
window.fc.hw = window.fc.hw || {};

(function (exports, Laya) {
    'use strict';

    class Channel {

        static init() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.init:", "qg is undefine");
                return false;
            }
            console.log("hw.init");
            qg.onError(function (data) {
                console.error(`hw error message is ${data.message}`);
            });

            return true;
        }

        /**用户同意隐私广告协议 */
        static setAgreeAd() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.init:", "qg is undefine");
                return;
            }
            qg.setUnderAgeOfPromise(false);
            qg.setConsentStatus(0);
            qg.setNonPersonalizedAd(0)
            this.initVideoAd(this.videoAdUnitId);
        }

        static exitApplication() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.init:", "qg is undefine");
                return;
            }
            qg.exitApplication({
                success: function () {
                    console.log("exitApplication success");
                },
                fail: function () {
                    console.log("exitApplication fail");
                },
                complete: function () {
                    console.log("exitApplication complete");
                }
            });
        }

        static initAdService(info) {
            if (!info) {
                console.warn("[adapter]Channel.init:", "info is invalid");
                return true;
            }
            if (info.videoInterval) {
                this.videoInterval = info.videoInterval;
            }

            if (info.appId) {
                this.appId = info.appId;
            }

            if (info.videoAdUnitId) {
                this.initVideoAdId(info.videoAdUnitId);
            }

            if (info.bannerAdUnitId) {
                this.initBannerAd(info.bannerAdUnitId, 1);
            }

            if (info.insertAdUnitId) {
                this.initInsertAd(info.insertAdUnitId);
            }

            if (info.nativeAdUnitId) {
                this.initNativeAd(info.nativeAdUnitId);
            }


            if (fc.framework.GameFrame.playerInfo.isAgreeAd && fc.framework.GameFrame.playerInfo.isAgreeAd == 1) {
                this.setAgreeAd();
            }

            return true;
        }

        /**初始化banner */
        static initBannerAd(bannerAdUnit, scale) {
            console.log("初始化banner", bannerAdUnit);
            this.bannerAdUnitId = bannerAdUnit;
            this.bannerAdScale = scale;
            return true;
        }

        static initNativeAd(nativeAdUnitId) {
            this.nativeAdUnitId = nativeAdUnitId;
            return true;
        }

        static initInsertAd(insertAdUnitId) {
            this.insertAdUnitId = insertAdUnitId;
            return true;
        }
        static initVideoAdId(videoAdUnit) {
            this.videoAdUnitId = videoAdUnit;
            return true;
        }

        /**初始化视频广告 */
        static initVideoAd(videoAdUnit) {
            this.rewardedVideoAd = null;
            this.isLoadedVideoAd = false;
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.initVideoAd:", "qg is undefine");
                return false;
            }
            if (videoAdUnit == null || videoAdUnit == "") {
                console.warn("[adapter]Channel.initVideoAd:", "videoAdUnit is invalid");
                return false;
            }
            if (typeof qg.createRewardedVideoAd != 'function') {
                console.warn("[adapter]Channel.initVideoAd:", "video is unsupported");
                return false;
            }
            var self = this;
            this.rewardedVideoAd = qg.createRewardedVideoAd({
                adUnitId: videoAdUnit,
                success: (code) => {

                    console.log("ad demo : 视频成功loadAndShowVideoAd createRewardedVideoAd: success");
                },
                fail: (data, code) => {
                    console.log("ad demo : 视频失败loadAndShowVideoAd createRewardedVideoAd fail: " + data + "," + code);
                },
                complete: () => {
                    console.log("ad demo : loadAndShowVideoAd createRewardedVideoAd complete");
                }
            });
            this.rewardedVideoAd.setNonPersonalizedAd(0);

            if (this.rewardedVideoAd == null) {
                console.warn("[adapter]Channel.initVideoAd:", "rewardedVideoAd is invalid");
                return false;
            }

            this.rewardedVideoAd.onError(function (err) {
                console.log("激励广告展示失败", err.errCode, JSON.stringify(err));
                self.isLoadedVideoAd = false;
                if (self.videoErrorHandler) {
                    self.videoErrorHandler.runWith(err);
                }
                // self.rewardedVideoAd.load();
            });

            this.rewardedVideoAd.onClose(function (res) {
                self.isLoadedVideoAd = false;
                if (res && res.isEnded || res === undefined) {
                    console.log('激励视频广告完成');
                    if (self.videoCompletedHandler) {
                        console.log(" 执行激励视频广告完成回调");
                        self.videoCompletedHandler.run();
                    }
                } else {
                    console.log("播放中途退出，不下发游戏奖励");
                    if (self.videoInterruptHandler) {
                        self.videoInterruptHandler.run();
                    }
                }
                self.rewardedVideoAd.load();
            });

            this.rewardedVideoAd.onLoad(() => {
                console.log('视频加载成功')
                self.isLoadedVideoAd = true;
            });

            this.rewardedVideoAd.load();
            return true;
        }

        static login(successHandler, failedHandler) {
            
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.login:", "qg is undefine");
                return false;
            }

            this.appId = fc.framework.GameFrame.appInfo.appId;
            console.log('appid', fc.framework.GameFrame.appInfo.appId);
            var self = this;
            qg.gameLoginWithReal({
                forceLogin: 1,
                appid: fc.framework.GameFrame.appInfo.appId || '',
                success: function (data) {
                    console.log("登陆成功 game login success:" + data, self.appId);
                    Laya.timer.scale = 1;
                    fc.framework.GameFrame.loadPlayerInfo();
                    fc.framework.GameFrame.savePlayerInfo(fc.framework.GameFrame.playerInfo);
                    if (fc.framework.GameFrame.playerInfo.isAgreeAd && fc.framework.GameFrame.playerInfo.isAgreeAd == 1) {
                        self.setAgreeAd();
                    }

                    // qg.savePlayerInfoWithReal({
                    //     success: function (data) { console.log("DUWENJUN save player info success:" + data); },
                    //     fail: function (data, code) { console.log("DUWENJUN save player info fail:" + data + ", code:" + code); }
                    // });
                },
                fail: function (data, code) {
                    console.log("DUWENJUN game login fail:" + data + ", code:" + code, self.appId);
                    console.log("登陆失败，不能进入游戏");
                    Laya.timer.scale = 0;
                    Laya.MouseManager.enabled = false;
                    self.showModal('登陆失败', '游戏登陆失败，是否退出游戏！', '重新登陆', '退出游戏', Laya.Handler.create(this, function (res) {
                        console.log("重新登陆");
                        self.login();
                        Laya.MouseManager.enabled = true;
                    }, null, false), Laya.Handler.create(this, function () {
                        console.log("退出游戏");
                        self.exitApplication();
                        Laya.MouseManager.enabled = true;
                    }, null, false));
                }
            });

            return true;
        }

        static loadSubpackage(pkgName, progressHandler, successHandler, failedHandler) {

            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.loadSubpackage:", "qg is undefine");
                return false;
            }



            console.log("---------------loadSubpackage: " + pkgName);

            var loadTask = qg.loadSubpackage({
                name: pkgName, // name 可以填 name 或者 root
                success(res) {
                    // 分包加载成功后通过 success 回调
                    successHandler && successHandler.runWith(1);
                },
                fail(res) {
                    // 分包加载失败通过 fail 回调
                    failedHandler && failedHandler.runWith(1);
                }
            });
            if (!loadTask) {
                console.warn("[adapter]Channel.loadSubpackage:", "loadTask is invalid");
                return false;
            }
            // if (progressHandler) {
            //     loadTask.onprogress(function (res) {
            //         progressHandler.runWith(res.progress);
            //     })
            // }
            return true;
        }

        static showModal(title, content, confirmTxt, cancelTxt, success, failed, completed) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.showModal:", "qg is undefine");
                return false;
            }
            qg.showModal({
                title: title,
                content: content,
                cancelText: cancelTxt,
                confirmText: confirmTxt,
                success(res) {
                    console.log('用户点击',res)
                    if (res.confirm) {
                        console.log('用户点击确定')
                        success && success.runWith(res);

                    } else if (res.cancel) {
                        console.log('用户点击取消')
                        failed && failed.run();
                    }
                }
            });
            return true;
        }

        static shareAppMessage(data, success, failed) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.shareAppMessage:", "qg is undefine");
                return false;
            }

            qg.systemShare({
                type: "text/plain",
                data: data.title || "",
                success() {
                    success && success.run();
                },
                fail() {
                    failed && failed.run();
                },
                cancel() {
                    failed && failed.run();
                },
                complete: function () {
                    console.info('share complete ');
                }
            })


            return true;
        }

        static createBannerAd(errorHandler) {
            console.log("createBannerAd");
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.createBannerAd:", "qg is undefine");
                return false;
            }

            if (this.bannerAdUnitId == null || this.bannerAdUnitId == "") {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAdUnitId is invalid");
                return false;
            }

            if (this.bannerAd != null) {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAd is exist");
                return false;
            }

            if (typeof qg.createBannerAd != 'function') {
                console.warn("[adapter]Channel.createBannerAd:", "banner is unsupported");
                return false;
            }

            this.bannerAdIsReady = false;
            this.bannerAdVisible = false;
            this.bannerErrorHandler = errorHandler;
            var slideScale = (1 - this.bannerAdScale) * 0.5;
            var systemInfo = qg.getSystemInfoSync();
            this.bannerAd = qg.createBannerAd({
                adUnitId: this.bannerAdUnitId,
                adIntervals: 60,
                style: {
                    top: systemInfo.windowHeight - 60,
                    left: systemInfo.windowWidth * slideScale,
                    height: 57,
                    width: 360
                }
            });

            if (this.bannerAd == null) {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAd is undefine");
                return false;
            }

            var self = this;
            this.bannerAd.onError(function (err) {
                console.log("banner广告展示失败onError", JSON.stringify(err));
                if (self.bannerErrorHandler) self.bannerErrorHandler.runWith(err);
            });
            return true;
        }

        /**显示banner */
        static showBannerAd() {
            console.log("showBannerAd");
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.showBannerAd:", "bannerAd is undefine");
                return false;
            }

            if (this.bannerAdVisible) {
                return true;
            }
            var self = this;
            this.bannerAd.show();
            // this.bannerAd.show().then(function () {
            //     if (self.bannerAdVisible == false) {
            //         self.hideBannerAd();
            //     }
            // });

            this.bannerAdVisible = true;
            return true;
        }

        /**隐藏banner */
        static hideBannerAd() {
            console.log("hideBannerAd");
            if (this.bannerAdVisible == false) {
                return true;
            }
            this.bannerAdVisible = false;
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.hideBannerAd:", "bannerAd is undefine");
                return true;
            }
            this.bannerAd.hide();
            // this.bannerAd.hide().then(function () {
            //     console.log("banner广告隐藏成功");
            // }).catch(function (err) {
            //     console.log("banner广告隐藏失败", err);
            // });
            return true;
        }

        static destroyBannerAd() {
            console.log("destroyBannerAd");
            this.bannerAdIsReady = false;
            this.bannerAdVisible = false;
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.destroyBannerAd:", "bannerAd is undefine");
                return false;
            }
            this.bannerAd.destroy();
            this.bannerAd = null;
            return true;
        }

        static isBannerAdValid() {
            return !!this.bannerAd;
        }

        /**播放视频广告 */
        static playVideo(completedHandler, interruptHandler, errorHandler) {
            // 第一次creat后广告可以在onload里面直接show
            // 后续的加载必须要load才能触发onload接着才能show出广告
            if (this.rewardedVideoAd == null) {
                console.warn("[adapter]Channel.playVideo:", "video is undefine");
                return false;
            }

            if (this.videoLastShowTime > 0 && Date.now() - this.videoLastShowTime < this.videoInterval) {
                console.warn("[adapter]Channel.playVideo:", "no valid video");
                return false;
            }


            this.videoErrorHandler = errorHandler;
            this.videoCompletedHandler = completedHandler;
            this.videoInterruptHandler = interruptHandler;

            if (!this.isLoadedVideoAd) {
                console.log("[adapter]视频木有Channel.playVideo2:", "no valid video");
                this.rewardedVideoAd.load();
                if (this.videoErrorHandler) {
                    this.videoErrorHandler.runWith(err);
                }
                return false;
            }

            var self = this;
            // this.rewardedVideoAd.show()
            //     .catch(function (err) {
            //         self.rewardedVideoAd.load()
            //             .then(function () { self.rewardedVideoAd.show() })
            //     });
            this.rewardedVideoAd.show();
            this.videoLastShowTime = Date.now();
            // if (this.firstPlay) {
            //     self.rewardedVideoAd.show();
            // } else {
            //     self.rewardedVideoAd.load().then(function () {
            //         self.rewardedVideoAd.show();
            //     });
            // }
            // this.firstPlay = false;

            return true;
        }

        static isVideoEnable() {
            return this.rewardedVideoAd != null && this.isLoadedVideoAd;
        }

        /**加载插屏广告 */
        static loadInsertAd(loadedHandler, errorHandler) {

            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.loadInsertAd:", "qg is undefine");
                return false;
            }

            if (this.insertAdUnitId == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "insertAdUnitId is undefine");
                return false;
            }

            if (typeof qg.createInterstitialAd != 'function') {
                console.warn("[adapter]Channel.createInterstitialAd:", "InterstitialAd is unsupported");
                return false;
            }

            this.insertAd = qg.createInterstitialAd({
                adUnitId: this.insertAdUnitId
            });
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "insertAd is undefine");
                return false;
            }

            this.insertAd.onLoad(function () {
                if (loadedHandler) {
                    loadedHandler.run();
                }
            });
            var self = this;
            this.insertAd.onError(function (err) {
                console.log("插屏广告错误事件", JSON.stringify(err));
                self.insertAd = null;
                if (errorHandler) {
                    errorHandler.runWith(err);
                }
            });

            this.insertAd.load();

            return true;

        }

        /**显示插屏广告 */
        static showInsertAd(closeHandler, errorHandler) {
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.showInsertAd:", "insertAd is undefine");
                return false;
            }

            var self = this;
            this.insertAd.onClose(function () {
                self.insertAd.destroy();
                self.insertAd = null;
                if (closeHandler) {
                    closeHandler.run();
                }
            });
            this.insertAd.onError(function (err) {
                console.log("插屏广告错误事件", JSON.stringify(err));
                self.insertAd.destroy();
                self.insertAd = null;
                if (errorHandler) {
                    errorHandler.runWith(err);
                }
            });

            this.insertAd.show();
            console.log("插屏显示成功");

            return true;
        }

        static createNativeAd(errorHandler) {

            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.initNativeAd:", "qg is undefine");
                return false;
            }

            if (typeof qg.createNativeAd != 'function') {
                console.warn("[adapter]Channel.createNativeAd:", "NativeAd is unsupported");
                return false;
            }



            if (this.nativeAdUnitId == null || this.nativeAdUnitId == '') {
                console.warn("[adapter]Channel.initNativeAd:", "nativeAdUnitId is undefine");
                return false;
            }

            this.nativeAdErrorHandler = errorHandler;
            this.nativeAd = qg.createNativeAd({
                adUnitId: this.nativeAdUnitId,
                success: (code) => {
                    console.log("原生广告成功loadNativeAd loadNativeAd : success");
                },
                fail: (data, code) => {
                    console.log("原生广告失败loadNativeAd loadNativeAd fail: " + data + "," + code);
                },
                complete: () => {
                    console.log("原生广告完成loadNativeAd loadNativeAd : complete");
                }
            });
            if (this.nativeAd == null) {
                console.warn("[adapter]Channel.initNativeAd:", "nativeAd is undefine");
                return false;
            }
            this.nativeAd.setNonPersonalizedAd(0);
            var self = this;
            this.nativeAd.onError(function (err) {
                console.log('原生广告加载失败', JSON.stringify(err));
                if (self.nativeAdErrorHandler) self.nativeAdErrorHandler.runWith(err);
            });

            return true;
        }

        /**加载原生广告 */
        static loadNativeAd(completedHandler, errorHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.loadNativeAd:", "qg is undefine");
                return false;
            }

            if (this.nativeAd == null) {
                console.warn("[adapter]Channel.loadNativeAd:", "nativeAd is invalid");
                return false;
            }

            this.nativeAdErrorHandler = errorHandler;
            this.nativeAdCompletedHandler = completedHandler;
            var self = this;
            this.nativeAd.onLoad(function (res) {
                console.log('原生广告加载完成', JSON.stringify(res));
                if (res && res.adList) {
                    if (self.nativeAdCompletedHandler) {
                        self.nativeAdCompletedHandler.runWith(res);
                    }
                }
            });

            this.nativeAd.load();
            // adLoad && adLoad.then(function () {
            //     console.log('原生广告加载完成', JSON.stringify(res));
            // }).catch(function(err) {
            //     if (errorHandler) errorHandler.run();
            // })
            return true;
        }

        /**上报原生广告显示 */
        static reportNativeAdShow(adId) {
            if (!this.nativeAd) {
                console.warn("[adapter]Channel.loadNativeAd:", "nativeAd is invalid");
                return false;
            }
            console.log("reportNativeAdShow:" + Date.now());
            this.nativeAd.reportAdShow({ adId: adId.toString() });
            return true;
        }

        /**上报原生广告点击 */
        static reportNativeAdClick(adId) {
            if (!this.nativeAd) {
                console.warn("[adapter]Channel.loadNativeAd:", "nativeAd is invalid");
                return false;
            }
            console.log("reportNativeAdClick:" + Date.now());
            this.nativeAd.reportAdClick({ adId: adId.toString() });
            return true;
        }

        //判断是否有桌面图标
        static hasDesktopIcon(successHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.hasDesktopIcon:", "qg is undefine");
                return false;
            }
            qg.hasInstalled({
                success: function (res) {
                    if (successHandler) successHandler.runWith({ hasIcon: res });
                },
                fail: function (err) {
                    console.log("request desktop icon error:" + JSON.stringify(err));
                },
                complete: function () { }
            });
            return true;
        }

        //创建桌面图标
        static createDesktopIcon(successHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.createDesktopIcon:", "qg is undefine");
                return false;
            }
            qg.install({
                success: function () {
                    console.log("create DesktopIcon success", successHandler);
                    if (successHandler) successHandler.runWith({ hasIcon: true });
                },
                fail: function (err) {
                    console.log("create desktop icon fail", err);
                },
                complete: function () {
                    console.log("create desktop icon complete");
                }
            });
            return true;
        }

        static getNetworkType(complete) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.getNetworkType:", "qg is undefine");
                return false;
            }
            qg.getNetworkType({
                success: function (data) {
                    console.log(`handling success: ${data.type}`)
                    if (data.type == "none") {
                        qg.showModal({
                            title: '提示',
                            content: '当前网络不可用，请检查是否连接网络',
                            success: function (data) {
                                console.log('handling callback')
                                qg.exitApplication();
                            },
                            cancel: function () {
                                qg.exitApplication();
                            },
                            fail: function (data, code) {
                                qg.exitApplication();
                            }
                        })
                    } else {
                        if (complete) complete.run();
                    }
                }
            });
            return true;
        }
    }
    Channel.rewardedVideoAd = null;
    Channel.videoCompletedHandler = null;
    Channel.videoInterruptHandler = null;
    Channel.videoErrorHandler = null;
    // Channel.firstPlay = true;
    Channel.videoInterval = 5000;
    Channel.videoLastShowTime = 0;
    Channel.bannerAd = null;
    Channel.bannerAdUnitId = null;
    Channel.bannerAdVisible = false;
    Channel.bannerAdIsReady = false;
    Channel.isLoadedVideoAd = false;
    Channel.bannerErrorHandler = null;
    Channel.insertAd = null;
    Channel.insertAdUnitId = null;
    Channel.videoAdUnitId = null;
    Channel.nativeAd = null;
    Channel.nativeAdUnitId = null;
    Channel.nativeAdErrorHandler = null;
    Channel.nativeAdLoadedHandler = null;
    Channel.bannerAdScale = 1;

    class Device {

        static get statusBarHeight() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Device.statusBarHeight:", "qg is undefine");
                return 0;
            }
            return (this.deviceInfo && this.deviceInfo.statusBarHeight) ? this.deviceInfo.statusBarHeight : 0;
        }

        static get screenWidth() {
            return this.deviceInfo ? this.deviceInfo.screenWidth : 1;
        }

        static get screenHeight() {
            return this.deviceInfo ? this.deviceInfo.screenHeight : 1;
        }

        static init(onShowHandler, onHideHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Device.init:", "qg is undefine");
                return false;
            }
            if (qg.getSystemInfoSync != 'function') {
                var self = this;
                qg.getSystemInfo({
                    success: function (res) {
                        self.deviceInfo = res;
                        // console.log("getSystemInfo success res = " + self.deviceInfo.statusBarHeight, self.deviceInfo.screenWidth);
                    },
                    fail: function () {
                        console.log("getSystemInfo fail");
                    },
                    complete: function () {
                        console.log("getSystemInfo complete");
                    }
                });
            } else {
                this.sDeviceInfo = qg.getSystemInfoSync();
            }


            console.log(this.deviceInfo);
            console.log("fcDevice.init");
            qg.onShow(function (res) {
                console.log("fcDevice.show:" + Date.now());
                if (onShowHandler) onShowHandler.runWith(res);
            });
            qg.onHide(function () {
                console.log("fcDevice.hide:" + Date.now());
                if (onHideHandler) onHideHandler.run();
            });
            return true;
        }

        static vibrateShort() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Device.vibrateShort:", "qg is undefine");
                return false;
            }
            qg.vibrateShort({
                fail: function () {
                    console.log("vibrateShort failed");
                },
                success: function () { },
                complete: function () { }
            });
            return true;
        }

        static vibrateLong() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Device.vibrateLong:", "qg is undefine");
                return false;
            }
            qg.vibrateLong({
                fail: function () {
                    console.log("vibrateLong failed");
                },
                success: function () { },
                complete: function () { }
            });
            return true;
        }

        static isNetValid() {
            return true;
        }

    }
    Device.deviceInfo = null;

    exports.Channel = Channel;
    exports.Device = Device;
}(window.fc.hw = window.fc.hw || {}, Laya));

window.fc.adapter = window.fc.hw;