window.fc = window.fc || {};
window.fc.zsks = window.fc.zsks || {};

(function (exports, Laya) {
    'use strict';
    var ZsSdk = window.zs.sdk;
    var Event = fc.define.Event;
    var GameFrame = fc.framework.GameFrame;
    class Channel {

        static init() {
            console.log("=================Channel init=========appId:", GameFrame.appInfo.appId);
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.init:", "ks is undefine");
                return false;
            }

            kwaigame.init({ "appId": GameFrame.appInfo.appId });
            return;
        }

        static initAdService(info) {
            console.log("================= 初始化广告服务 =========appId:", info);
            if (!info) {
                console.warn("[adapter]Channel.init:", "info is invalid");
                return true;
            }

            if (info.videoAdUnitId) {
                console.log("================= 初始化视频 =========appId:", info.videoAdUnitId);
                this.initVideoAd(info.videoAdUnitId);
            }

            // if (info.bannerAdUnitId) {
            //     this.initBannerAd(info.bannerAdUnitId, info.bannerAdScale || 1);
            // }

            // if (info.insertAdUnitId) {
            //     this.initInsertAd(info.insertAdUnitId);
            // }
            return true;
        }

        static initBannerAd(bannerAdUnitId, bannerAdScale) {
            this.bannerAdUnitId = bannerAdUnitId;
            this.bannerAdScale = bannerAdScale;
            return true;
        }

        static initVideoAd(videoAdUnit) {
            this.rewardedVideoAd = null;
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.initVideoAd:", "ks is undefine");
                return false;
            }
            if (videoAdUnit == null || videoAdUnit == "") {
                console.warn("[adapter]Channel.initVideoAd:", "videoAdUnit is invalid");
                return false;
            }
            this.rewardedVideoAd = ks.createRewardedVideoAd({ adUnitId: videoAdUnit });
            if (this.rewardedVideoAd == null) {
                console.warn("[adapter]Channel.initVideoAd:", "rewardedVideoAd is invalid");
                return false;
            }
            var self = this;
            this.rewardedVideoAd.onError(function (err) {
                console.log(err);
                self.rewardedVideoAd = null;
                if (self.videoErrorHandler) {
                    self.videoErrorHandler.runWith(err);
                }
            });

            this.rewardedVideoAd.onClose(function (res) {
                // 用户点击了【关闭广告】按钮
                // 小于 2.1.0 的基础库版本，res 是一个 undefined
                if (res && res.isEnded || res === undefined) {
                    // 正常播放结束，可以下发游戏奖励
                    if (self.videoCompletedHandler) {
                        self.videoCompletedHandler.run();
                    }
                } else {
                    // 播放中途退出，不下发游戏奖励
                    if (self.videoInterruptHandler) {
                        self.videoInterruptHandler.run();
                    }
                }
            });
            return true;
        }

        static initInsertAd(inserAdUnitId) {
            this.inserAdUnitId = inserAdUnitId;
            return true;
        }

        static login(successHandler, failedHandler) {

            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.login:", "ks is undefine");
                return false;
            }

            this.loginSuccess = successHandler;
            this.loginFailed = failedHandler;
            this.loginNum++;
            var self = this;

            // ks.login({
            //     success: (result) => {
            //         console.log("快手登录成功:" + JSON.stringify(result));
            //         if (self.loginSuccess) self.loginSuccess.runWith({ identityId: res.code });
            //     },
            //     fail: (error) => {
            //         console.log("快手登录失败:" + JSON.stringify(error));
            //         if (self.loginNum <= 3) {
            //             self.login(self.loginSuccess, self.loginFailed);
            //         } else {
            //             self.loginNum = 0;
            //             if (self.failedHandler) self.failedHandler.runWith({ code: 2, desc: "login platform error" });
            //         }
            //     }
            // });

            var self = this;
            ZsSdk.login(function (openid) {
                if (openid) {
                    ZsSdk.init(openid);
                    self.openid = openid;
                    if (self.loginSuccess) self.loginSuccess.runWith({ identityId: openid });
                }
                else {
                    if (self.failedHandler) self.failedHandler.runWith({ code: 2, desc: "Code不存在" });
                }
            },
                function () {
                    if (self.failedHandler) self.failedHandler.runWith({ code: 2, desc: "login platform error" });
                }
            );
            return true;
        }

        static loadCfg(success,fail) {
            ZsSdk.loadCfg(
                function (data) {
                    if (data) {
                        success(data);
                    }
                },
                function () {
                    fail();
                });
        }

        static loadSubpackage(pkgName, progressHandler, successHandler, failedHandler) {

            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.loadSubpackage:", "ks is undefine");
                return false;
            }

            var loadTask = ks.loadSubpackage({
                name: pkgName, // name 可以填 name 或者 root
                success(res) {
                    // 分包加载成功后通过 success 回调
                    successHandler && successHandler.runWith(1);
                },
                fail(res) {
                    // 分包加载失败通过 fail 回调
                    failedHandler && failedHandler.runWith(1);
                }
            });
            if (!loadTask) {
                console.warn("[adapter]Channel.loadSubpackage:", "loadTask is invalid");
                return false;
            }
            // if (progressHandler) {
            // loadTask.onProgressUpdate(res => {
            //     progressHandler && progressHandler.runWith(res.progress);
            //     console.log("快手分包加载进度：", res.progress);
            // });
            // }
            return true;
        }

        static navigate2Mini(appId, path, extraData, success, failed, completed) {
            // if (typeof ks == "undefined") {
            //     console.warn("[adapter]Channel.navigate2Mini:", "ks is undefine");
            //     return false;
            // }
            // ks.navigateToMiniProgram({
            //     appId: appId,
            //     path: path,
            //     extraData: extraData,
            //     success: function (e) {
            //         success && success.run();
            //     },
            //     fail: function (e) {
            //         failed && failed.run();
            //     },
            //     complete: function (e) {
            //         completed && completed.run();
            //     }
            // })
            return true;
        }

        static showModal(title, content, confirmTxt, cancelTxt, success, failed, complete) {

            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.showModal:", "ks is undefine");
                return false;
            }

            ks.showModal({
                title: title,
                content: content,
                cancelText: cancelTxt,
                confirmText: confirmTxt,
                success(res) {
                    success && success.runWith(res);
                },
                fail() {
                    failed && failed.run();
                },
                complete() {
                    complete && complete.run();
                }
            });

            return true;
        }

        static shareAppMessage(data, success, failed) {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.shareAppMessage:", "ks is undefine");
                return false;
            }
            var shareInfo = data || {};
            Laya.stage.off(Event.DEVICE_HIDE, this, this.onShareOpen);
            Laya.stage.on(Event.DEVICE_HIDE, this, this.onShareOpen, [success, failed, Date.now()]);
            ks.shareAppMessage(shareInfo);
            return true;
        }

        static onShareOpen(success, failed, openTimestamp) {
            console.log("onShareOpen");
            Laya.stage.off(Event.DEVICE_HIDE, this, this.onShareOpen);
            Laya.stage.on(Event.DEVICE_SHOW, this, this.onShareReturn, [success, failed, openTimestamp]);
        }

        static onShareReturn(success, failed, openTimestamp) {
            console.log("onShareReturn");
            Laya.stage.off(Event.DEVICE_SHOW, this, this.onShareReturn);
            if (Date.now() - openTimestamp > 5000) {
                success && success.run();
            }
            else {
                failed && failed.run();
            }
        }

        static createBannerAd(errorHandler) {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.createBannerAd:", "ks is undefine");
                return false;
            }

            if (this.bannerAdUnitId == null || this.bannerAdUnitId == "") {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAdUnitId is invalid");
                return false;
            }

            if (this.bannerAd != null) {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAd is exist");
                return false;
            }

            this.bannerAdIsReady = false;
            this.bannerAdVisible = false;
            this.bannerErrorHandler = errorHandler;
            var slideScale = (1 - this.bannerAdScale) * 0.5;
            var systemInfo = ks.getSystemInfoSync();
            this.bannerAd = ks.createBannerAd({
                adUnitId: this.bannerAdUnitId,
                style: {
                    top: systemInfo.windowHeight - 100,
                    width: systemInfo.windowWidth * this.bannerAdScale,
                    left: systemInfo.windowWidth * slideScale
                }
            });

            if (this.bannerAd == null) {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAd is undefine");
                return false;
            }

            var self = this;
            // 720 * 250
            this.bannerAd.onResize(function (size) {
                console.log(systemInfo);
                if (self.bannerAd) {
                    self.bannerAd.style.top = window.screen.availHeight - size.height;
                    self.bannerAd.style.left = (window.screen.availWidth - size.width) * 0.5;
                }
            });

            this.bannerAd.onError(function (err) {
                console.log(err);
                self.bannerAd = null;
                if (self.bannerErrorHandler) {
                    self.bannerErrorHandler.run();
                }
            });

            this.bannerAd.onLoad(function () {
                self.bannerAdIsReady = true;
                if (self.bannerAdVisible) {
                    self.bannerAd.show();
                }
            });

            return true;
        }

        static showBannerAd() {
            console.log("showBannerAd");
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.showBannerAd:", "bannerAd is undefine");
                return false;
            }
            if (this.bannerAdIsReady && !this.bannerAdVisible) {
                this.bannerAd.show();
            }
            this.bannerAdVisible = true;
            return true;
        }

        static hideBannerAd() {
            console.log("hideBannerAd");
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.hideBannerAd:", "bannerAd is undefine");
                return false;
            }
            if (this.bannerAdIsReady && this.bannerAdVisible) {
                this.bannerAd.hide();
            }
            this.bannerAdVisible = false;
            return true;
        }

        static destroyBannerAd() {
            console.log("destroyBannerAd");
            this.bannerAdIsReady = false;
            this.bannerAdVisible = false;
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.destroyBannerAd:", "bannerAd is undefine");
                return false;
            }
            this.bannerAd.destroy();
            this.bannerAd = null;
            return true;
        }

        static isBannerAdValid() {
            return !!this.bannerAd;
        }

        static playVideo(completedHandler, interruptHandler, errorHandler) {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.playVideo:", "ks is undefine");
                return false;
            }
            if (this.rewardedVideoAd == null) {
                console.warn("[adapter]Channel.playVideo:", "video is undefine");
                return false;
            }
            this.videoErrorHandler = errorHandler;
            this.videoCompletedHandler = completedHandler;
            this.videoInterruptHandler = interruptHandler;

            var self = this;
            this.rewardedVideoAd.show()
                .catch(function (err) {
                    self.rewardedVideoAd.load()
                        .then(function () { self.rewardedVideoAd.show() })
                });
            return true;
        }

        static isVideoEnable() {
            return this.rewardedVideoAd != null;
        }

        static loadInsertAd(loadedHandler, errorHandler) {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.loadInsertAd:", "ks is undefine");
                return false;
            }
            if (this.inserAdUnitId == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "inserAdUnitId is undefine");
                return false;
            }
            if (typeof ks.createInterstitialAd != 'function') {
                console.warn("[adapter]Channel.initInsertAd:", "interstitialAd is unsupported");
                return;
            }

            this.insertAd = ks.createInterstitialAd({ adUnitId: this.inserAdUnitId });
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "inserAdUnitId is undefine");
                return false;
            }

            var self = this;
            this.insertAd.onLoad(function () {
                if (loadedHandler) {
                    loadedHandler.run();
                }
            });

            this.insertAd.onError(function (err) {
                console.log(err);
                self.insertAd = null;
                if (errorHandler) {
                    errorHandler.runWith(err);
                }
            });

            return true;
        }

        static showInsertAd(closeHandler, errorHandler) {
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.showInsertAd:", "insertAd is undefine");
                return false;
            }

            var self = this;
            this.insertAd.onClose(function () {
                self.insertAd = null;
                if (closeHandler) {
                    closeHandler.runWith();
                }
            });

            this.insertAd.onError(function (err) {
                console.log(err);
                self.insertAd = null;
                if (errorHandler) {
                    errorHandler.runWith(err);
                }
            });

            this.insertAd.show();
            return true;
        }

        static isInsertAdEnable() {
            return true;
        }

        static isRecorderEnable() {
            // if (ks && ks.getGameRecorder) {
            //     return true;
            // } else {
            //     console.error("快手没有isFrameSupported （判断是否拥有录屏功能）方法！");
            //     return false;
            // }
            return true;
        }

        static startRecorder(iMaxTime) {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.startRecorder:", "ks is undefine");
                return false;
            }
            if (typeof ks.getGameRecorder !== 'function') {
                console.warn("[adapter]Channel.startRecorder:", "getGameRecorder is undefine");
                return false;
            }
            if (this.recorder == null) {
                this.recorder = ks.getGameRecorder();
                if (this.recorder != null) {
                    var self = this;
                    this.recorder.on('start', () => {
                        self.recording = true;
                        self.recorderTime = Date.now();
                        console.log(`开始录制视频`)
                    });
                    // stop 事件的回调函数
                    this.recorder.on('stop', res => {
                        // 录制结束的回调，此时回调给用户videoID，发布录屏携带的必填参数
                        console.log(`停止录制视频 videoID is ${res.videoID}`);
                        self.recording = false;
                        self.videoPath = res.videoID;
                    })
                    this.recorder.on('error', res => {
                        console.log('错误码', res.error.code);
                        console.log('错误信息', res.error.message);
                    });
                } else {
                    console.log(`==============开始录制视频失败============`)
                }
            }
            if (this.recorder == null) {
                console.warn("[adapter]Channel.startRecorder:", "unsupport");
                return false;
            }
            this.recorderTime = 0;
            this.recorder.start();
            return true;
        }

        static stopRecorder() {
            if (!this.recording) {
                console.warn("[adapter]Channel.stopRecorder:", "it is not in record");
                return false;
            }
            if (this.recorder == null) {
                console.warn("[adapter]Channel.stopRecorder:", "unsupport");
                return false;
            }
            this.recorder.stop();
            this.recording = false;
            return true;
        }

        static pauseRecorder() {
            if (!this.recording) {
                console.warn("[adapter]Channel.pauseRecorder:", "it is not in record");
                return false;
            }
            if (this.recorder == null) {
                console.warn("[adapter]Channel.pauseRecorder:", "unsupport");
                return false;
            }
            this.recorder.pause();
            this.recording = false;
            return true;
        }

        static resumeRecorder() {
            if (this.recording) {
                console.warn("[adapter]Channel.resumeRecorder:", "it is in record");
                return false;
            }
            if (this.recorder == null) {
                console.warn("[adapter]Channel.resumeRecorder:", "unsupport");
                return false;
            }
            this.recorder.resume();
            this.recording = true;
            return true;
        }

        static canShareRecorder() {
            return this.recorderTime > 5000;
        }

        static hideShareRecBtn() {
            //     console.log("hideShareRecBtn");
            //     if (this.recordShareBtn) {
            //         this.recordShareBtn.hide();
            //     }
        }

        static shareAppMessage(data, success, fail) {

            if (typeof ks == "undefined") {
                console.warn("[adapter]Channel.showShareRecBtn:", "ks is undefine");
                return false;
            }

            // if (this.videoPath == '') {
            //     console.warn("[adapter]Channel.shareAppMessage:", "videoPath is invalid");
            //     return false;
            // }

            console.log("shareVideo", this.videoPath);
            var videoInfo = {
                video: this.videoPath,
                callback: (error) => {
                    if (error != null && error != undefined) {
                        console.log("分享录屏失败: " + JSON.stringiwfy(error));
                        fail && fail.run();
                        return;
                    } else {
                        console.log("分享录屏成功");
                        success && success.run();
                    }
                }
            };
            console.log("分享录屏", videoInfo)
            this.recorder.publishVideo(videoInfo);
            return true;
        }
    }
    Channel.loginNum = 0;
    Channel.rewardedVideoAd = null;
    Channel.videoCompletedHandler = null;
    Channel.videoInterruptHandler = null;
    Channel.videoErrorHandler = null;
    Channel.insertAd = null;
    Channel.inserAdUnitId = null;
    Channel.bannerAd = null;
    Channel.bannerAdUnitId = null;
    Channel.bannerAdScale = 1;
    Channel.bannerAdIsReady = false;
    Channel.bannerAdVisible = false;
    Channel.bannerErrorHandler = null;
    Channel.recorder = null;
    Channel.recorderTime = 0;
    Channel.recording = false;
    Channel.recordShareBtn = null;

    var validNetConnectType = ["2g", "3g", "4g", "5g", "wifi"];

    class Device {

        static get statusBarHeight() {
            return this.sDeviceInfo ? this.sDeviceInfo.statusBarHeight : 0;
        }

        static get screenWidth() {
            return this.sDeviceInfo ? this.sDeviceInfo.screenWidth : 1;
        }

        static get screenHeight() {
            return this.sDeviceInfo ? this.sDeviceInfo.screenHeight : 1;
        }

        static init(onShowHandler, onHideHandler) {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Device.init:", "ks is undefine");
                return false;
            }

            this.sDeviceInfo = ks.getSystemInfoSync();
            console.log(this.sDeviceInfo);
            console.log("ksDeviceAdapter.init");
            ks.onShow(function (res) {
                console.log("ksDeviceAdapter.show:" + Date.now());
                if (onShowHandler) onShowHandler.runWith(res);
            });
            ks.onHide(function () {
                console.log("ksDeviceAdapter.hide:" + Date.now());
                if (onHideHandler) onHideHandler.run();
            });
            // var self = this;
            // ks.onNetworkStatusChange && ks.onNetworkStatusChange(function (res) {
            //     self.sNetworkType = res.networkType;
            //     self.sIsNetConnected = res.isConnected;
            // });
            // ks.getNetworkType && ks.getNetworkType({
            //     success(res) {
            //         self.sNetworkType = res.networkType;
            //     }
            // });
            return true;
        }

        static vibrateShort() {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Device.vibrateShort:", "ks is undefine");
                return false;
            }
            ks.vibrateShort({
                fail: function () {
                    console.log("vibrateShort failed");
                },
            });
            return true;
        }

        static vibrateLong() {
            if (typeof ks == "undefined") {
                console.warn("[adapter]Device.vibrateLong:", "ks is undefine");
                return false;
            }
            ks.vibrateLong({
                fail: function () {
                    console.log("vibrateShort failed");
                },
            });
            return true;
        }

        static isNetValid() {
            return this.sIsNetConnected && validNetConnectType.indexOf(this.sNetworkType) != -1;
        }

        static playMusic(res) {
            if (typeof ks == "undefined") {
                Laya.SoundManager.playMusic(res, 0);
            }
            else {
                console.log("快手播放背景音乐：", res);
                this.playSound(res, true,);
            }
        }

        static stopMusic(res) {
            if (typeof ks == "undefined") {
                Laya.SoundManager.stopMusic(res);
            }
            else {
                console.log("快手播放背景音乐：", res);
                this.stopSound(res, true,);
            }
        }

        static playSound(res, loop, compHandler) {
            if (typeof ks == "undefined") {
                Laya.SoundManager.playSound(res, loop ? 0 : 1, compHandler);
                return;
            }

            var audio = null;
            let self = this;
            if (this.sSoundInfo[res]) {
                audio = this.sAudioArr[this.sSoundInfo[res]["idx"]];
                // console.debug("取到" + res + "的音频");
                if (!this.sSoundInfo[res]["isStop"]) {
                    // console.debug("" + res + "已在播放中");
                    self.sContinue = true;
                    if (!loop) {
                        audio.stop();
                        audio.offEnded();

                        audio.src = res;
                        audio.loop = loop;
                        this.sSoundInfo[res] = { "idx": this.sAudioArr.indexOf(audio), "ptime": new Date().getTime(), "isStop": false, "curTime": 0 };
                        audio.onEnded(function () {
                            if (compHandler) compHandler.run();
                        });
                        audio.play();
                    }
                    return;
                }
            }
            if (!audio) {
                audio = ks.createInnerAudioContext();
                this.sAudioArr.push(audio);
                audio.onError(function (eCode) {
                    console.debug("音效播放异常  code " + JSON.stringify(eCode));
                    self.sAudioArr.splice(self.sSoundInfo[audio.src]["idx"]);
                    delete self.sSoundInfo[audio.src];
                    audio.destroy();
                });
            }
            audio.src = res;
            audio.loop = loop;
            this.sSoundInfo[res] = { "idx": this.sAudioArr.indexOf(audio), "ptime": new Date().getTime(), "isStop": false, "curTime": 0 };
            audio.onEnded(function () {
                if (compHandler) compHandler.run();
            });
            audio.play();
        }

        // static pauseSound(res) {
        //     var audio = this.sAudioArr[this.sSoundInfo[res]["idx"]];
        //     if (!audio) return;
        //     audio.pause();
        //     audio.offEnded();
        // }

        static stopSound(res) {
            if (typeof ks == "undefined") {
                Laya.SoundManager.stopSound(res);
                return;
            }

            if (!this.sSoundInfo[res]) return;
            this.sContinue = false;
            var a = new Date().getTime() - this.sSoundInfo[res]["ptime"]
            if (a < 300) {
                console.debug("间隔过短，延时关闭");
                let self = this;
                setTimeout(function () {
                    if (!self.sSoundInfo[res]) return;
                    var audio = self.sAudioArr[self.sSoundInfo[res]["idx"]];
                    if (!audio || self.sSoundInfo[res]["isStop"] || self.sContinue) return;
                    self.sSoundInfo[res]["isStop"] = true;
                    audio.stop();
                    audio.offEnded();
                    console.debug("进入延时关闭");
                }, 300 - a);
                return;
            }
            var audio = this.sAudioArr[this.sSoundInfo[res]["idx"]];
            audio.stop();
            audio.offEnded();
            this.sSoundInfo[res]["isStop"] = true;
            console.debug("进入关闭");
        }

        static stopAll() {
            this.stopMusic();
            this.stopAllSound();
        }

        static stopAllSound() {
            for (const key in this.sSoundInfo) {
                this.stopSound(key);
            }
        }
    }
    Device.sAudioArr = [];
    Device.sSoundInfo = {};
    Device.sContinue = false;
    Device.sDeviceInfo = null;
    Device.sNetworkType = null;
    Device.sIsNetConnected = false;

    exports.Channel = Channel;
    exports.Device = Device;

}(window.fc.zsks, Laya))

window.fc.adapter = window.fc.zsks