window.fc = window.fc || {};
window.fc.zsoppo = window.fc.zsoppo || {};
(function (exports, Laya) {
    'use strict';
    var ZsSdk = window.zs.sdk;
    class Channel {
        
        static init() {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.init:", "qg is undefine");
                return false;
            }
            console.log("oppo.init");
            qg.onError(function(res){
                console.error(res);
            });
            return true;
        }

        static initAdService(info) {

            if (!info || !info.appId) {
                console.warn("[adapter]Channel.init:", "info is invalid");
                return true;
            }

            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.init:", "qg is undefine");
                return false;
            }

            qg.initAdService({
                appId: info.appId,
                isDebug: false,
                success: function (res) {
                    console.log("success");
                },
                fail: function (res) {
                    console.log("fail:" + res.code + res.msg);
                },
                complete: function (res) {
                    console.log("complete");
                }
            });
            
            this.gameStartTime = Date.now();
            this.adShowCount = 0;
            this.adMaxCount = info.adMaxCount || 2;
            if (info.videoAdUnitId) {
                this.initVideoAd(info.videoAdUnitId);
            }

            if (info.bannerAdUnitId) {
                this.initBannerAd(info.bannerAdUnitId, 1);
            }

            if (info.insertAdUnitId) {
                this.initInsertAd(info.insertAdUnitId);
            }

            if (info.nativeAdUnitId) {
                this.initNativeAd(info.nativeAdUnitId);
            }

            if (info.gameBoxUnitId) {
                this.initGameBox(info.gameBoxUnitId);
            }

            if (info.gameBannerUnitId) {
                this.initGameBanner(info.gameBannerUnitId);
            }

            console.log("initAdService", info);
            return true;
        }

        static initVideoAd(videoAdUnit) {
            this.rewardedVideoAd = null;
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.initVideoAd:", "qg is undefine");
                return false;
            }
            if (videoAdUnit == null || videoAdUnit == "") {
                console.warn("[adapter]Channel.initVideoAd:", "videoAdUnit is invalid");
                return false;
            }
            this.createVideoAdNum += 1;
            this.rewardedVideoAd = qg.createRewardedVideoAd({
                posId: videoAdUnit
            })
            if (this.rewardedVideoAd == null) {
                return false;
                // if (this.createVideoAdNum > 3) {
                //     console.warn("[adapter]Channel.initVideoAd:", "rewardedVideoAd is invalid");
                //     return false;
                // }
                // console.log("初始化视频失败，重新初始化:" + this.createVideoAdNum);
                // return this.initVideoAd(videoAdUnit);
            }
            var self = this;
            this.videoReady = false;
            this.videoRequirePlay = false;

            this.rewardedVideoAd.load();
            this.rewardedVideoAd.onLoad(function () {
                console.log("激励视频加载成功");
                self.videoReady = true;
                if (self.videoRequirePlay) {
                    self.rewardedVideoAd.show();
                    self.videoRequirePlay = false;
                }
            });
            this.rewardedVideoAd.onError(function (err) {
                console.log("激励视频错误：", err);
                self.rewardedVideoAd = null;
                self.videoReady = false;
                self.videoRequirePlay = false;
                if (self.videoErrorHandler) {
                    self.videoErrorHandler.runWith(err);
                }
            });

            this.rewardedVideoAd.onClose(function (res) {
                // 用户点击了【关闭广告】按钮
                // 小于 2.1.0 的基础库版本，res 是一个 undefined
                self.videoReady = false;
                self.videoRequirePlay = false;
                self.rewardedVideoAd.load();

                if (res.isEnded) {
                    // 正常播放结束，可以下发游戏奖励
                    if (self.videoCompletedHandler) {
                        self.videoCompletedHandler.run();
                    }

                    console.log('激励视频广告完成，发放奖励:' + Date.now());
                } else {
                    // 播放中途退出，不下发游戏奖励
                    if (self.videoInterruptHandler) {
                        self.videoInterruptHandler.run();
                    }
                    console.log('激励视频广告取消关闭，不发放奖励:' + Date.now());
                }
            })
            return true;
        }

        static initBannerAd(bannerAdUnit, scale) {
            this.bannerAdUnitId = bannerAdUnit;
            this.bannerAdIndex = Math.floor( Math.random() * this.bannerAdUnitId.length);
            return true;
        }

        static initInsertAd(insertAdUnitId) {
            this.insertAdUnitId = insertAdUnitId;
            return true;
        }

        static initNativeAd(nativeAdUnitId) {
            this.nativeAdUnitId = nativeAdUnitId;
            this.nativeAdIndex = Math.floor( Math.random() * this.nativeAdUnitId.length);
            return true;
        }

        static initGameBox(gameBoxUnitId) {
            console.log("initGameBox:", gameBoxUnitId);
            this.gameBoxUnitId = gameBoxUnitId;
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.initGameBox:", "qg is undefine");
                return false;
            }
            if(qg.getSystemInfoSync().platformVersionCode >= 1076) {
                this.gameBoxAd = qg.createGamePortalAd({
                    adUnitId: this.gameBoxUnitId
                });
                return true;
            } else {
                console.log('快应用平台版本号低于1076，暂不支持互推盒子相关 API');
                return false;
            }
        }

        static isGameBoxValid() {
            return this.gameBoxAd != null;
        }

        static initGameBanner(gameBannerUnitId) {
            this.gameBannerUnitId = gameBannerUnitId;
        }

        static createGameBanner(errorHandle, config) {
            console.log("createGameBanner");
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.initGameBanner:", "qg is undefine");
                return false;
            }
            if(qg.getSystemInfoSync().platformVersionCode >= 1076) {
                this.gameBannerAd = qg.createGameBannerAd({
                  adUnitId: this.gameBannerUnitId
                });
                return true;
            } 
            else {
                console.log('快应用平台版本号低于1076，暂不支持互推盒子相关 API');
                return false;
            }
        }

        static showGameBanner() {
            console.log("showGameBanner");
            if (this.gameBannerAd) {
                this.gameBannerAd.show().then(function() {
                    console.log('show success')
                }).catch(function(error) {
                    console.log('show fail with:' + error.errCode + ',' + error.errMsg)
                })
                return true;
            }
            else {
                return false;
            }
        }

        static hideGameBanner() {
            console.log("hideGameBanner");
            if (this.gameBannerAd) {
                this.gameBannerAd.hide().then(function() {
                    console.log('hide success')
                }).catch(function(error) {
                    console.log('hide fail with:' + error.errCode + ',' + error.errMsg)
                })
                return true;
            }
            else {
                return false;
            }
        }

        static destroyGameBanner() {
            console.log("destroyGameBanner");
            if (this.gameBannerAd) {
                gameBannerAd.destroy().then(function() {
                    console.log('destroy success')
                }).catch(function(error) {
                    console.log('destroy fail with:' + error.errCode + ',' + error.errMsg)
                });
                this.gameBannerAd = null;
                return true;
            }
            else {
                return false;
            }
        }

        static showGameBox(success, fail, close) {
            console.log("showGameBox");
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.showGameBox:", "qg is undefine");
                return false;
            }
            
            if (!this.gameBoxAd) {
                console.warn("[adapter]Channel.showGameBox:", "gameBoxAd is undefine");
                return false;
            }

            var self = this;
            this.gameBoxAd.onClose(function(){
                close && close.run();
            });
            
            var self = this;
            this.gameBoxAd.load().then(function() {
                console.log('load success')
                self.gameBoxAd.show().then(function(){
                    console.log('show gameBoxAd success')
                    success && success.run();
                }).catch(function(error) {
                    console.log('show gameBoxAd fail with:' + error.errCode + ',' + error.errMsg)
                    fail && fail.runWith(error.errMsg);
                });
            }).catch(function(error) {
                console.log('load fail with:' + error.errCode + ',' + error.errMsg)
                fail && fail.runWith(error.errMsg);
            });
            return true;
        }
        
        static login(successHandler, failedHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.login:", "qg is undefine");
                return false;
            }

            this.loginSuccess = successHandler;
            this.loginFailed = failedHandler;
            this.loginNum++;
            // qg.login({
            //     success: function(res){
            //         // console.log("登录成功：",data);
            //         if(successHandler)successHandler.runWith({identityId:res.data.token});
                    
            //     },
            //     fail: function(res){
            //         if(this.loginNum <= 3){
            //             setTimeout(function (){
            //                 console.log("----------延迟登录");
            //                 this.login(this.loginSuccess,this.loginFailed);
            //             },200);
            //         }else{
            //             if(failedHandler)failedHandler.runWith({code:2,desc:"login platform error"});
            //         }
            //     }
            // });

            var self = this;
            ZsSdk.login(function (openid) {
                if (openid) {
                    ZsSdk.init(openid);
                    self.openid = openid;
                    if (self.loginSuccess) self.loginSuccess.runWith({ identityId: openid });
                }
                else {
                    if (self.failedHandler) self.failedHandler.runWith({ code: 2, desc: "Code不存在" });
                }
            },
                function () {
                    if (self.failedHandler) self.failedHandler.runWith({ code: 2, desc: "login platform error" });
                }
            );
            return true;
        }

            
        static loadCfg(success,fail) {
            ZsSdk.loadCfg(
                function (data) {
                    if (data) {
                        success(data);
                    }
                },
                function () {
                    fail();
                });
        }

        static loadSubpackage(pkgName, progressHandler, successHandler, failedHandler) {
            
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.loadSubpackage:", "qg is undefine");
                return false;
            }

            var loadTask = qg.loadSubpackage({
                name: pkgName, // name 可以填 name 或者 root
                fail(res) {
                    console.log(res);
                },
                complete() {
                    successHandler && successHandler.runWith(1);
                }
            });
            if (!loadTask) {
                console.warn("[adapter]Channel.loadSubpackage:", "loadTask is invalid");
                return false;
            }
            // if (progressHandler) {
            //     loadTask.onProgressUpdate(function (res) {
            //         progressHandler.runWith(res.progress);
            //     })
            // }
            return true;
        }

        static navigate2Mini(appId, path, extraData, success, failed, completed) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.navigate2Mini:", "qg is undefine");
                return false;
            }
            // qg.navigateToMiniGame({
            //     pkgName: appId,
            //     path: path,
            //     extraData: extraData,
            //     success: function() {
            //         success && success.run();
            //     },
            //     fail: function(res) {
            //         failed && failed.run();
            //     },
            //     complete: function (e) {
            //         completed && completed.run();
            //     }
            //   })
            return true;
        }

        static showModal(title, content, confirmTxt, cancelTxt, success, failed, completed) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.showModal:", "qg is undefine");
                return false;
            }
            qg.showModal({
                title: title,
                content: content,
                cancelText: cancelTxt,
                confirmText: confirmTxt,
                success (res) {
                    success && success.runWith(res);
                },
                fail () {
                    failed && failed.run();
                },
                complete () {
                    completed && completed.run();
                }
              });
            return true;
        }

        static isVideoEnable() {
            return this.rewardedVideoAd != null && this.videoReady;
        }

        static playVideo(completedHandler, interruptHandler, errorHandler) {
            if (this.rewardedVideoAd == null) {
                console.warn("[adapter]Channel.playVideo:", "video is undefine");
                return false;
            }
            this.videoErrorHandler = errorHandler;
            this.videoCompletedHandler = completedHandler;
            this.videoInterruptHandler = interruptHandler;

            if (this.videoReady) {
                this.rewardedVideoAd.show();
                console.log('playVideo' + Date.now());
            }
            else {
                this.videoRequirePlay = true;
                this.rewardedVideoAd.load();
            }
        }

        static createBannerAd(errorHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.createBannerAd:", "qg is undefine");
                return false;
            }

            if (this.bannerAdUnitId == null || this.bannerAdUnitId.length == 0) {
                console.warn("[adapter]Channel.createBannerAd:", "bannerAdUnitId is invalid");
                return false;
            }
            console.log("初始化banner:",this.bannerAdUnitId);
            this.createBannerNum += 1;
            this.bannerErrorHandler = errorHandler;
            var sysInfo = qg.getSystemInfoSync();
            if (sysInfo.platformVersionCode < 1051) {
                console.warn("[adapter]Channel.createBannerAd:", "platformVersionCode < 1051");
                return false;
            }

            this.bannerAd = qg.createBannerAd({
                adUnitId: this.bannerAdUnitId[this.bannerAdIndex]
            });

            this.bannerAdIndex = (this.bannerAdIndex + 1) % this.bannerAdUnitId.length;

            if (this.bannerAd == null) {
                console.log("banner create fail");
                return false;
                // if (this.createBannerNum > 3) {
                //     console.warn("[adapter]Channel.createBannerAd:", "bannerAd is undefine");
                //     return false;
                // }
                // return this.createBannerAd(this.bannerAdUnitId, this.bannerErrorHandler);
            }
            console.log("banner create success");
            var self = this;
            this.bannerAd.onError(function (err) {
                console.log("bannerAd error:", err);
                if (self.bannerErrorHandler) {
                    self.bannerErrorHandler.run();
                }

                if (!self.bannerAd) {
                    console.log("bannerAd lose");
                }
            });
            return true;
        }

        static showBannerAd() {
            console.log("showBannerAd");
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.showBannerAd:", "bannerAd is undefine");
                return false;
            }
            if (this.gameStartTime > 0 && this.adShowCount / Math.ceil((Date.now() - this.gameStartTime)/60000) > this.adMaxCount) {
                console.warn("平均一分钟内banner和原生超过2次:", "广告展示频繁");
                return false;
            }
            if(fc.framework.GameFrame.pluginCfg.ps_onemin_show_ad_switch == 1 && Date.now() - this.gameStartTime < 60000){
                console.warn("开始一分钟内不出现广告:", "开始一分钟内不出现广告");
                return false;
            }

            console.log("bannerAd show");
            this.bannerAd.show();
            this.bannerAdVisible = true;
            this.adShowCount++;
            return true;
        }

        static hideBannerAd() {
            console.log("hideBannerAd");
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.hideBannerAd:", "bannerAd is undefine");
                return false;
            }

            this.bannerAd.hide();
            this.bannerAdVisible = false;
            return true;
        }

        static destroyBannerAd() {
            console.log("destroyBannerAd");
            this.bannerAdIsReady = false;
            this.bannerAdVisible = false;
            if (!this.bannerAd) {
                console.warn("[adapter]Channel.destroyBannerAd:", "bannerAd is undefine");
                return false;
            }
            this.bannerAd.destroy();
            this.bannerAd = null;
            return true;
        }

        static isBannerAdValid() {
            return !!this.bannerAd;
        }

        static loadInsertAd(loadedHandler, errorHandler) {

            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.loadInsertAd:", "qg is undefine");
                return false;
            }
            if (this.insertAdUnitId == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "insertAdUnitId is undefine");
                return false;
            }

            console.log("初始化插屏广告：" + this.insertAdUnitId);
            this.insertAd = qg.createInsertAd({ 
                posId: this.insertAdUnitId 
            });
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.loadInsertAd:", "insertAd is undefine");
                return false;
            }

            this.insertAd.onLoad(function(){
                console.log("插屏广告加载成功");
                if (loadedHandler) {
                    loadedHandler.run();
                }
            });
            var self = this;
            this.insertAd.onError(function(err){
                console.log("插屏广告失败");
                console.log(err);
                self.insertAd=null;
                if (errorHandler) {
                    errorHandler.runWith(err);
                }
            });
            this.insertAd.load();
            
            return true;
        }

        static showInsertAd(closeHandler, errorHandler) {
            if (this.insertAd == null) {
                console.warn("[adapter]Channel.showInsertAd:", "insertAd is undefine");
                return false;
            }

            var self = this;
            this.insertAd.onClose(function () {
                self.insertAd = null;
                if (closeHandler) {
                    closeHandler.run();
                }
            });        
            this.insertAd.onError(function (err) {
                console.log(err);
                self.insertAd = null;
                if (errorHandler) {
                    errorHandler.runWith(err);
                }
            });
            this.insertAd.show();
            console.log("播放插屏广告");
            return true;
        }

        static createNativeAd(errorHandler) {
            
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.initNativeAd:", "qg is undefine");
                return false;
            }

            if (this.nativeAdUnitId == null || this.nativeAdUnitId.length == 0) {
                console.warn("[adapter]Channel.initNativeAd:", "nativeAdUnitId is undefine");
                return false;
            }
            if (this.nativeAd) {
                this.nativeAd.destroy();
            }
            
            if (this.gameStartTime > 0 && this.adShowCount / Math.ceil((Date.now() - this.gameStartTime)/60000) > this.adMaxCount) {
                console.warn("平均一分钟内banner和原生超过2次:", "广告展示频繁");
                return false;
            }

            if(fc.framework.GameFrame.pluginCfg.ps_onemin_show_ad_switch == 1 && Date.now() - this.gameStartTime < 60000){
                console.warn("开始一分钟内不出现广告:", "开始一分钟内不出现广告");
                return false;
            }

            this.nativeAdErrorHandler = errorHandler;
            this.nativeAd = qg.createNativeAd({ 
                posId:this.nativeAdUnitId[this.nativeAdIndex]
            });

            this.nativeAdIndex = (this.nativeAdIndex + 1) % this.nativeAdUnitId.length;

            if (this.nativeAd == null) {
                console.warn("[adapter]Channel.initNativeAd:", "nativeAd is undefine");
                return false;
            }

            var self = this;
            this.nativeAd.onError(function(err){
                console.log("原生广告失败");
                console.log(err);
                if (self.nativeAdErrorHandler) {
                    self.nativeAdErrorHandler.runWith(err);
                }
            });

            return true;
        }

        static loadNativeAd(completedHandler, errorHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.loadNativeAd:", "qg is undefine");
                return false;
            }

            if (this.nativeAd == null) {
                console.warn("[adapter]Channel.loadNativeAd:", "nativeAd is invalid");
                return false;
            }

            
            if (this.gameStartTime > 0 && this.adShowCount / Math.ceil((Date.now() - this.gameStartTime)/60000) > this.adMaxCount) {
                console.warn("平均一分钟内banner和原生超过2次:", "广告展示频繁");
                return false;
            }

            this.nativeAdErrorHandler = errorHandler;
            this.nativeAd.onLoad(function (res){
                console.log('原生广告加载完成', JSON.stringify(res));
                if (res && res.adList) {
                    if (completedHandler) {
                        completedHandler.runWith(res);
                    }
                }
            });

            this.nativeAd.load();
            this.adShowCount++;
            return true;
        }

        static reportNativeAdShow(adId) {
            if (!this.nativeAd || !adId) {
                console.warn("[adapter]Channel.loadNativeAd:", "nativeAd is invalid");
                return false;
            }
            console.log("reportNativeAdShow:" + Date.now());
            this.nativeAd.reportAdShow({ adId: adId.toString() });
            return true;
        }

        static reportNativeAdClick(adId) {
            if (!this.nativeAd || !adId) {
                console.warn("[adapter]Channel.loadNativeAd:", "nativeAd is invalid");
                return false;
            }
            console.log("reportNativeAdClick:" + Date.now());
            this.nativeAd.reportAdClick({ adId: adId.toString() });
            return true;
        }

        //判断是否有桌面图标
        static hasDesktopIcon(successHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.hasDesktopIcon:", "qg is undefine");
                return false;
            }
            qg.hasShortcutInstalled({
                success: function(res){
                    // var data = JSON.stringify(res);
                    if(successHandler)successHandler.runWith({hasIcon:res});
                },
                fail: function(err){
                    console.log("request desktop icon error:" + JSON.stringify(err));
                }
            });
            return true;
        }

        //创建桌面图标
        static createDesktopIcon(successHandler) {
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.createDesktopIcon:", "qg is undefine");
                return false;
            }
            qg.installShortcut({
                success: function(res){
                    // var data = JSON.stringify(res);
                    if(successHandler)successHandler.runWith();
                    console.log("create DesktopIcon success:",res);
                },
                fail: function(err){
                    console.log("create desktop icon fail",err);
                },
                complete:function(){
                    console.log("create desktop icon complete");
                }
            });
            return true;
        }

        static reportMonitor(name, value){
            if (typeof qg == "undefined") {
                console.warn("[adapter]Channel.reportMonitor:", "qg is undefine");
                return false;
            }    
            const sysInfo = qg.getSystemInfoSync();
            if(sysInfo.platformVersionCode < 1060) {
                console.warn("[adapter]Channel.reportMonitor:", "platformVersionCode < 1060");
                return false;
            }
            qg.reportMonitor(name, value);
            return true;
        }

    }
    Channel.loginNum = 0;
    Channel.videoAdUnit = null;
    Channel.createVideoAdNum = 0;
    Channel.rewardedVideoAd = null;
    Channel.videoReady = false;
    Channel.videoRequirePlay = false;
    Channel.videoCompletedHandler = null;
    Channel.videoInterruptHandler = null;
    Channel.videoErrorHandler = null;
    Channel.bannerAdUnitId = null;
    Channel.bannerAd = null;
    Channel.bannerErrorHandler = null;
    Channel.createBannerNum = 0;
    Channel.insertAd = null;
    Channel.insertAdUnitId = null;
    Channel.nativeAd = null;
    Channel.nativeAdErrorHandler = null;
    Channel.nativeAdLoadedHandler = null;
    Channel.gameStartTime = 0;
    Channel.adShowCount = 0;
    Channel.adMaxCount = 2;
    Channel.gameBoxUnitId = null;
    Channel.gameBoxAdReady = true;
    Channel.gameBoxAd = null;
    Channel.gameBannerUnitId = null;
    Channel.gameBannerAd = null;
    Channel.nativeAdIndex = 0;
    Channel.bannerAdIndex = 0;

    class Device {        

        static get statusBarHeight() {
            return this.sDeviceInfo ? this.sDeviceInfo.notchHeight : 0;
        }

        static get screenWidth() {
            return this.sDeviceInfo ? this.sDeviceInfo.screenWidth : 1;
        }

        static get screenHeight() {
            return this.sDeviceInfo ? this.sDeviceInfo.screenHeight : 1;
        }

        static init(showHandler, hideHandler) {
            console.log("oppoDevice.init");
            if (typeof qg == "undefined") {
                console.warn("oppoDevice.init", "qg is undefined");
                return ;
            }
            this.sDeviceInfo = qg.getSystemInfoSync()
            console.log(this.sDeviceInfo);

            qg.onShow(function (res) {
                console.log("oppoDevice.show:" + Date.now());
                if (showHandler)showHandler.runWith(res);
            });

            qg.onHide(function () {
                console.log("oppoDevice.hide:" + Date.now());
                if (hideHandler)hideHandler.run();
            });
        }
        
        static vibrateShort() {  
            if (typeof qg == "undefined") {
                return ;
            }    
            qg.vibrateShort({
                fail: function() {
                    console.log("vibrateShort failed");
                },
                success: function() {},
                complete: function() {}
            });
        }
        
        static vibrateLong() {   
            if (typeof qg == "undefined") {
                return ;
            }       
            qg.vibrateLong({
                fail: function() {
                    console.log("vibrateLong failed");
                },
                success: function() {},
                complete: function() {}
            });
        }

        static isNetValid() {
            return true;
        }

    }
    Device.sDeviceInfo = null;

    exports.Channel = Channel;
    exports.Device = Device;
}(window.fc.zsoppo = window.fc.zsoppo || {}, Laya));

window.fc.adapter = window.fc.zsoppo;