window.fc = window.fc || {};
window.fc.ad = window.fc.ad || {};
window.fc.ad.export = window.fc.ad.export || {};
(function (exports, Laya) {
    'use strict';

    var GameFrame = fc.framework.GameFrame;
    var Event = fc.define.Event;

    exports.loadAd = function (callback) {
        if (callback) {
            callback([]);
        }
    }

    exports.navigate2Mini = function (data, successCb, cancelCb, completedCb) {
        if (cancelCb) {
            cancelCb.run();
        }
    }

    class AdList extends Laya.Script {

        constructor() {
            super();

            this.adType = null;
            this.autoScroll = false;
            this.scrollDir = AdList.SCROLL_NONE;

            this.dragSleep = 5000;
            this.scrollSpeed = 1;//2800;
            this.waitTime = 1000;

            this.passedTime = 0;
            this.inAutoScroll = false;

            this.adData = [];
            this.iosFilterAppIds = [];

            this.list = null;
            this.hotIds = [];

            this.minNum = null;
            this.isDataUpdate = false;

            this.isRandomSelect = false;

            this.changeValue = 0;
            this.unitValue = 0;
            this.isEnd = false;

            this.isClockPendulum = false;

            this.jumpTimestamp = 0;
        }

        /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
        requestAdData(adType, autoScroll, scrollDir, iosFilterAppIds, minNum, randomSelect, isClockPendulum) {
            this.adType = adType;
            this.autoScroll = autoScroll;
            this.scrollDir = scrollDir;
            this.iosFilterAppIds = iosFilterAppIds || [];
            this.minNum = minNum;
            this.isRandomSelect = randomSelect;
            this.isClockPendulum = isClockPendulum;
            if (this.scrollDir == AdList.SCROLL_VERTICAL) {
                this.list.vScrollBarSkin = "";
            }
            else if (this.scrollDir == AdList.SCROLL_HORIZONTAL) {
                this.list.hScrollBarSkin = "";
            }
            var self = this;
            exports.loadAd(function (data) {
                if (self.list) {
                    data.sort(function () { return Math.random() > 0.5 ? 1 : -1; });
                    self.adData = data;
                    self.initHotIds();
                    self.freshAdList();
                }
            }, this.adType);
        }

        freshAdList() {
            if (this.adData == null || this.adData.length == 0) {
                this.list.array = [];
                return 0;
            }
            var self = this;
            this.adData = this.adData.filter(function (elment) {
                return Laya.Browser.onAndroid || self.iosFilterAppIds.indexOf(elment.appid) == -1;
            })
            if (this.minNum != null) {
                if (this.adData.length < this.minNum) {
                    while (this.adData.length < this.minNum) {
                        this.adData.push(this.adData[Math.floor(Math.random() * this.adData.length)]);
                    }
                }
                // else if (this.adData.length > this.minNum) {
                //     while (this.adData.length > this.minNum) {
                //         this.adData.splice(Math.floor(Math.random() * this.adData.length), 1);
                //     }
                // }
            }
            this.list.array = this.adData;

            var unitNum = 0;
            var ceil = this.list.getCell(0);
            if (!ceil) return;//计算单元格对应滑动值
            if (this.scrollDir == AdList.SCROLL_VERTICAL) {
                unitNum = Math.ceil(this.list.array.length / this.list.repeatX);
                this.unitValue = (ceil.height + this.list.spaceY) / (unitNum * ceil.height + this.list.spaceY * (unitNum - 1) - this.list.height) * this.list.scrollBar.max;
            } else if (this.scrollDir == AdList.SCROLL_HORIZONTAL) {
                unitNum = Math.ceil(this.list.array.length / this.list.repeatY);
                this.unitValue = (ceil.width + this.list.spaceX) / (unitNum * ceil.width + this.list.spaceX * (unitNum - 1) - this.list.width) * this.list.scrollBar.max;
            }
            console.log("单元value" + this.unitValue);

            if (this.autoScroll) {
                Laya.stage.frameOnce(1, this, this.startAutoScrollAd);
            }
        }

        initHotIds() {
            var hotNum = Math.random() < 0.5 ? 3 : 4;
            var interval = Math.floor(this.adData.length / hotNum);
            for (var index = 0; index < hotNum; index++) {
                this.hotIds.push(Math.floor(interval * Math.random()) + index * interval);
            }
        }

        startAutoScrollAd() {
            if (!this.list) {
                return;
            }
            this.inAutoScroll = true;
        }

        onItemRender(item, index) {
            var data = this.list.array[index];
            if (!data) {
                item.visible = false;
                return;
            }
            var icon = item.getChildByName("icon");
            if (icon) {
                icon.loadImage(data.app_icon, Laya.Handler.create(this, this.onImageReady, [icon, icon.width]));
            } else {
                var iconBox = item.getChildByName("iconBox");
                if (iconBox) {
                    var icon = iconBox.getChildByName("icon");
                    if (icon) {
                        icon.skin = data.app_icon;
                    }
                }
            }
            var name = item.getChildByName("name");
            if (name) {
                name.text = data.app_title;
            }
            var desc = item.getChildByName("desc");
            if (desc) {
                desc.text = data.app_desc;
            }
            if (this.isDataUpdate == true) {
                return
            }
            var titleBg = item.getChildByName("titleBg");
            if (titleBg) {
                titleBg.index = Math.floor(titleBg.clipY * Math.random());
            }
            var tag = item.getChildByName("tag");
            if (tag) {
                if (this.hotIds.indexOf(index) > 0) {
                    tag.visible = true;
                    tag.index = Math.floor(tag.clipY * Math.random());
                }
                else {
                    tag.visible = false;
                }
            }
            else {
                var hotTag = item.getChildByName("hot");
                var newTag = item.getChildByName("new");
                hotTag && (hotTag.visible = false);
                newTag && (newTag.visible = false);
                if (this.hotIds.indexOf(index) > 0) {
                    if (hotTag && newTag) {
                        if (Math.random() < 0.5) {
                            hotTag.visible = true;
                        }
                        else {
                            newTag.visible = true;
                        }
                    }
                    else if (hotTag && !newTag) {
                        hotTag.visible = true;
                    }
                    else if (newTag && !hotTag) {
                        newTag.visible = true;
                    }
                }
            }
        }

        onImageReady(icon, width) {
            icon.width = icon.height = width;
        }

        onSelectAd(index) {
            if (index == null || index == -1) {
                return;
            }
            if (!this.list) {
                return;
            }
            if (!this.list.array) {
                return;
            }
            var data = this.list.array[index];
            var self = this;
            self.isDataUpdate = true;
            if (Date.now() - this.jumpTimestamp > 50) {
                this.jumpTimestamp = Date.now();
                data.fcAdType = this.adType;
                fc.ad.export.navigate2Mini(data,
                    Laya.Handler.create(this, function () {
                        Laya.stage.event(Event.APP_JUMP_SUCCESS, data);
                    }, [data]),
                    Laya.Handler.create(this, function () {
                        Laya.stage.event(Event.APP_JUMP_CANCEL, data);
                    }, [data]),
                    Laya.Handler.create(this, function () {
                        self.list.selectedIndex = -1;
                        Laya.stage.event(Event.APP_JUMP_COMPLETED, data);
                    }, [data]));
            }
            else {
                this.owner.frameOnce(2, this, function() {
                    self.list.selectedIndex = -1;
                })
            }
            this.randomRefreshCeil(index);
        }

        randomRefreshCeil(index) {
            //更换该位置的数据
            let data = this.adData[Math.floor(Math.random() * this.adData.length)];
            this.list.setItem(index, data);
        }

        params2String(args) {
            var params = args[0] + "=" + args[1];
            for (var index = 2; index < args.length; index += 2) {
                params += "&" + args[index] + "=" + args[index + 1];
            }
            return params;
        }

        onDragStateChanged(newState) {
            this.inAutoScroll = false;
            if (this.autoScroll && newState == 0) {
                this.passedTime = 0;
            }
            if (newState == 0 && this.isRandomSelect) {
                this.owner.frameOnce(2, this, this.onTouchEnd);
            }
        }

        onTouchEnd() {
            if (this.list == null || this.list.array.length == 0) {
                return;
            }
            // this.onSelectAd(Math.floor(Math.random(this.list.array.length)));
        }

        onAwake() {
            this.list = this.owner;
            this.list.selectEnable = true;
            this.list.renderHandler = Laya.Handler.create(this, this.onItemRender, null, false);
            this.list.selectHandler = Laya.Handler.create(this, this.onSelectAd, null, false);
        }

        onEnable() {
            this.list.on(Laya.Event.MOUSE_UP, this, this.onDragStateChanged, [0]);
            this.list.on(Laya.Event.MOUSE_OUT, this, this.onDragStateChanged, [0]);
            this.list.on(Laya.Event.MOUSE_DOWN, this, this.onDragStateChanged, [1]);
        }

        onDisable() {
            this.list.off(Laya.Event.MOUSE_UP, this, this.onDragStateChanged);
            this.list.off(Laya.Event.MOUSE_OUT, this, this.onDragStateChanged);
            this.list.off(Laya.Event.MOUSE_DOWN, this, this.onDragStateChanged);
        }

        onUpdate() {

            if (this.autoScroll && this.inAutoScroll == true && this.list && this.list.scrollBar && this.list.scrollBar.max) {
                if (this.list.scrollBar.value >= this.list.scrollBar.max) {
                    this.list.scrollBar.value = this.list.scrollBar.max;
                    this.scrollSpeed = 0 - this.scrollSpeed;
                    this.isEnd = true;
                }
                else if (this.list.scrollBar.value <= 0) {
                    this.list.scrollBar.value = 0;
                    this.scrollSpeed = 0 - this.scrollSpeed;
                    this.isEnd = true;
                }
                this.list.scrollBar.value += this.scrollSpeed;
                if (!this.unitValue || !this.isClockPendulum) return;
                this.isEnd = this.isEnd && this.changeValue != 0;
                this.changeValue += Math.abs(this.scrollSpeed);
                if (this.changeValue >= this.unitValue || this.isEnd) {
                    this.autoScroll = false;
                    this.isEnd = false;
                    this.changeValue = 0;
                    Laya.timer.once(this.waitTime, this, function () {
                        this.autoScroll = true;
                    })
                }
            }
            if (this.autoScroll && this.inAutoScroll == false) {
                this.passedTime += Laya.timer.delta;
                if (this.passedTime > this.dragSleep) {
                    this.startAutoScrollAd();
                }
            }

        }
    }
    AdList.SCROLL_NONE = 0;
    AdList.SCROLL_VERTICAL = 1;
    AdList.SCROLL_HORIZONTAL = 2;
    AdList.RandomSelect = true;

    class AdList2 extends AdList {
        constructor() {
            super();
        }

        onItemRender(item, index) {
            var data = this.list.array[index];
            if (!data) {
                item.visible = false;
                return;
            }

            if (this.isDataUpdate == true) {
                return;
            }

            var icon = item.getChildByName("icon");
            if (icon) {
                if (index != 6) {
                    icon.visible = true;
                    icon.loadImage(data.app_icon, null);
                }
                else {
                    icon.visible = false;
                }
            }
            var name = item.getChildByName("name");
            if (name) {
                name.text = index != 6 ? data.app_title : "";
            }
            var desc = item.getChildByName("desc");
            if (desc) {
                desc.text = index != 6 ? data.app_desc : "";
            }

            var arrow = item.getChildByName("arrow");
            if (arrow) {
                arrow.visible = index == 6;
                if (index == 6) {
                    arrow.visible = true;
                    arrow.index = data.arrowIdx ? data.arrowIdx : 0;
                }
                else {
                    arrow.visible = false;
                }
            }
        }

        onSelectAd(index) {
            if (index == -1) {
                return;
            }
            var data = this.list.array[index];
            if (index == 6) {
                if (data.arrowIdx == null || data.arrowIdx == 0) {
                    data.arrowIdx = 1;
                    this.owner.event(Event.UI_SWITCH_SHOW);
                }
                else {
                    data.arrowIdx = 0;
                    this.owner.event(Event.UI_SWITCH_HIDE);
                }
                this.list.selectedIndex = -1;
                return;
            }
            var self = this;
            self.isDataUpdate = true;
            data.fcAdType = this.adType;
            fc.ad.export.navigate2Mini(data,
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_SUCCESS, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_CANCEL, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    self.list.selectedIndex = -1;
                    Laya.stage.event(Event.APP_JUMP_COMPLETED, data);
                }, [data]));
        }
    }

    class AdListRank extends AdList {
        constructor() {
            super();
        }

        onItemRender(item, index) {
            var data = this.list.array[index];
            if (!data) {
                item.visible = false;
                return;
            }
            var icon = item.getChildByName("icon");
            if (icon) {
                icon.loadImage(data.app_icon, Laya.Handler.create(this, this.onImageReady, [icon, icon.width]));
            } else {
                var iconBox = item.getChildByName("iconBox");
                if (iconBox) {
                    var icon = iconBox.getChildByName("icon");
                    if (icon) {
                        icon.skin = data.app_icon;
                    }
                }
            }
            var name = item.getChildByName("name");
            if (name) {
                name.text = data.app_title;
            }
            var desc = item.getChildByName("desc");
            if (desc) {
                desc.text = data.app_desc;
            }


            var rank = item.getChildByName("rank");
            if (rank) {
                rank.text = (index + 4) + "";

                let playerNum = item.getChildByName("playerNum");
                if (playerNum) {
                    playerNum.text = Math.floor(Math.random() * 60 + 10)  + "万人在玩";
                }
            }

            var rankImg = item.getChildByName("rankImg");
            if (rankImg) {
                rankImg.skin = "fc-res/export/img_Corner_" + (index + 1) + ".png";

                var rankBg = item.getChildByName("rankBg");
                if (rankBg) {
                    rankBg.skin = "fc-res/export/img_rankBg_" + (index + 1) + ".png";
                }

                let playerNum = item.getChildByName("playerNum");
                if (playerNum) {
                    playerNum.text = Math.floor(Math.random() * 500 + 100)  + "万人在玩";
                }

                if(index == 1){
                    item.y = -70;
                }
            }


            if (this.isDataUpdate == true) {
                return
            }
            var titleBg = item.getChildByName("titleBg");
            if (titleBg) {
                titleBg.index = Math.floor(titleBg.clipY * Math.random());
            }
            var tag = item.getChildByName("tag");
            if (tag) {
                if (this.hotIds.indexOf(index) > 0) {
                    tag.visible = true;
                    tag.index = Math.floor(tag.clipY * Math.random());
                }
                else {
                    tag.visible = false;
                }
            }
            else {
                var hotTag = item.getChildByName("hot");
                var newTag = item.getChildByName("new");
                hotTag && (hotTag.visible = false);
                newTag && (newTag.visible = false);
                if (this.hotIds.indexOf(index) > 0) {
                    if (hotTag && newTag) {
                        if (Math.random() < 0.5) {
                            hotTag.visible = true;
                        }
                        else {
                            newTag.visible = true;
                        }
                    }
                    else if (hotTag && !newTag) {
                        hotTag.visible = true;
                    }
                    else if (newTag && !hotTag) {
                        newTag.visible = true;
                    }
                }
            }
        }

    }

    class ExportScrollH extends Laya.Script {
        constructor() {
            super();
            this.adList = null;
        }

        initView(data) {
            this.adList = this.owner.getChildByName("adList").addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList.requestAdData(data.adType, true, AdList.SCROLL_HORIZONTAL, data.iosFilterAppIds, 9, AdList.RandomSelect, data.isClockPendulum);
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportScrollH", ExportScrollH);

    class ExportScrollV extends Laya.Script {
        constructor() {
            super();
            this.adList = null;
            this.list = null;
            this.guideFinger = null;
            this.localPoint = new Laya.Point();
        }

        initView(data) {

            this.list = this.owner.getChildByName("adList");
            this.adList = this.list.addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList.requestAdData(data.adType, true, AdList.SCROLL_VERTICAL, data.iosFilterAppIds, 8, AdList.RandomSelect, data.isClockPendulum);
            Laya.loader.create("fc-layout/prefab/guide/ef_finger.json", Laya.Handler.create(this, this.onPrefabReady), null, Laya.Loader.PREFAB);

        }

        onPrefabReady(prefab) {
            if (this.destroyed) {
                return;
            }
            this.guideFinger = prefab.create();
            this.guideFinger.visible = false;
            this.owner.addChild(this.guideFinger);
            this.freshFingerFocus();
            this.owner.timerLoop(2000, this, this.freshFingerFocus);
        }
        freshFingerFocus() {
            if (this.list instanceof Laya.List) {

                let index = Math.floor(Math.random() * 6 + this.list.startIndex);
                index = Math.min(this.list.length - 1, index);
                var element = this.list.getCell(index);
                this.updateFocus(element);

            }
        }


        updateFocus(comp) {
            if (comp == null || this.guideFinger == null) {
                return;
            }
            this.guideFinger.visible = true;
            this.localPoint.x = comp.width * 0.5;
            this.localPoint.y = comp.height * 0.5;
            comp.localToGlobal(this.localPoint, false, this.owner);
            this.guideFinger.pos(this.localPoint.x, this.localPoint.y);
            this.guideFinger.ef_finger.stop();
            this.guideFinger.ef_finger.play(0, true);
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportScrollV", ExportScrollV);

    class ExportFull extends Laya.Script {
        constructor() {
            super();
            this.list = [];
            this.adList1 = null;
            this.adList2 = null;
            this.adList3 = null;
            this.guideFinger = null;
            this.localPoint = new Laya.Point();
        }

        initView(data) {
            this.list.push(this.owner.getChildByName("adList1"));
            this.adList1 = this.owner.getChildByName("adList1").addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList1.requestAdData(data.adType, false, AdList.SCROLL_NONE, data.iosFilterAppIds, 4, AdList.RandomSelect, data.isClockPendulum);

            this.list.push(this.owner.getChildByName("adList2"));
            this.adList2 = this.owner.getChildByName("adList2").addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList2.requestAdData(data.adType, true, AdList.SCROLL_HORIZONTAL, data.iosFilterAppIds, 8, AdList.RandomSelect, data.isClockPendulum);

            this.list.push(this.owner.getChildByName("adList3"));
            this.adList3 = this.owner.getChildByName("adList3").addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList3.requestAdData(data.adType, true, AdList.SCROLL_VERTICAL, data.iosFilterAppIds, 15, AdList.RandomSelect, data.isClockPendulum);

            Laya.loader.create("fc-layout/prefab/guide/ef_finger.json", Laya.Handler.create(this, this.onPrefabReady), null, Laya.Loader.PREFAB);

        }


        onPrefabReady(prefab) {
            if (this.destroyed) {
                return;
            }
            this.guideFinger = prefab.create();
            this.guideFinger.visible = false;


            this.freshFingerFocus();
            this.owner.timerLoop(2000, this, this.freshFingerFocus);
        }
        freshFingerFocus() {
            let curList = this.list[Math.floor(Math.random() * this.list.length)];
            this.owner.addChild(this.guideFinger);
            if (curList instanceof Laya.List) {

                let index = Math.floor(Math.random() * 6 + curList.startIndex);
                index = Math.min(curList.length - 1, index);
                var element = curList.getCell(index);
                this.updateFocus(element);

            }
        }


        updateFocus(comp) {
            if (comp == null || this.guideFinger == null) {
                return;
            }
            this.guideFinger.visible = true;
            this.localPoint.x = comp.width * 0.5;
            this.localPoint.y = comp.height * 0.5;
            comp.localToGlobal(this.localPoint, false, this.owner);
            this.guideFinger.pos(this.localPoint.x, this.localPoint.y);
            this.guideFinger.ef_finger.stop();
            this.guideFinger.ef_finger.play(0, true);
        }

    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportFull", ExportFull);

    class ExportFull2 extends Laya.Script {
        constructor() {
            super();
            this.list = [];
            this.adList1 = null;
            this.adList2 = null;
            this.adList3 = null;
            this.guideFinger = null;
            this.localPoint = new Laya.Point();
        }

        initView(data) {
            this.list.push(this.owner.getChildByName("adList1"));
            this.adList1 = this.owner.getChildByName("adList1").addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList1.requestAdData(data.adType, true, AdList.SCROLL_HORIZONTAL, data.iosFilterAppIds, 8, AdList.RandomSelect, data.isClockPendulum);

            this.list.push(this.owner.getChildByName("adList3"));
            this.adList3 = this.owner.getChildByName("adList3").addComponent(AdList);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList3.requestAdData(data.adType, true, AdList.SCROLL_VERTICAL, data.iosFilterAppIds, 15, AdList.RandomSelect, data.isClockPendulum);

            Laya.loader.create("fc-layout/prefab/guide/ef_finger.json", Laya.Handler.create(this, this.onPrefabReady), null, Laya.Loader.PREFAB);

        }


        onPrefabReady(prefab) {
            if (this.destroyed) {
                return;
            }
            this.guideFinger = prefab.create();
            this.guideFinger.visible = false;


            this.freshFingerFocus();
            this.owner.timerLoop(2000, this, this.freshFingerFocus);
        }
        freshFingerFocus() {
            let curList = this.list[Math.floor(Math.random() * this.list.length)];
            this.owner.addChild(this.guideFinger);
            if (curList instanceof Laya.List) {

                let index = Math.floor(Math.random() * 6 + curList.startIndex);
                index = Math.min(curList.length - 1, index);
                var element = curList.getCell(index);
                this.updateFocus(element);

            }
        }


        updateFocus(comp) {
            if (comp == null || this.guideFinger == null) {
                return;
            }
            this.guideFinger.visible = true;
            this.localPoint.x = comp.width * 0.5;
            this.localPoint.y = comp.height * 0.5;
            comp.localToGlobal(this.localPoint, false, this.owner);
            this.guideFinger.pos(this.localPoint.x, this.localPoint.y);
            this.guideFinger.ef_finger.stop();
            this.guideFinger.ef_finger.play(0, true);
        }

    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportFull2", ExportFull2);

    class ExportFullRank extends Laya.Script {
        constructor() {
            super();
            this.list = [];
            this.adList1 = null;
            this.adList2 = null;
            this.adList3 = null;
            this.guideFinger = null;
            this.localPoint = new Laya.Point();
        }

        initView(data) {
            this.list.push(this.owner.getChildByName("adList1"));
            this.adList1 = this.owner.getChildByName("adList1").addComponent(AdListRank);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList1.requestAdData(data.adType, false, AdList.SCROLL_NONE, data.iosFilterAppIds, 3, AdList.RandomSelect, data.isClockPendulum);

            this.list.push(this.owner.getChildByName("adList3"));
            this.adList3 = this.owner.getChildByName("adList3").addComponent(AdListRank);
            /**导出位类型，是否自动滚动，滚动方向，ios是否屏蔽id，列表显示的最大个数，是否随机选择,是否移动一个暂停一下 */
            this.adList3.requestAdData(data.adType, true, AdList.SCROLL_VERTICAL, data.iosFilterAppIds,  this.adList1.adData.length, AdList.RandomSelect, data.isClockPendulum);
            let rankData = this.adList1.adData.concat();
            rankData.shift();
            rankData.shift();
            rankData.shift();
            this.adList3.adData = rankData;
            this.adList3.freshAdList(); 
            Laya.loader.create("fc-layout/prefab/guide/ef_finger.json", Laya.Handler.create(this, this.onPrefabReady), null, Laya.Loader.PREFAB);

        }


        onPrefabReady(prefab) {
            if (this.destroyed) {
                return;
            }
            this.guideFinger = prefab.create();
            this.guideFinger.visible = false;


            this.freshFingerFocus();
            this.owner.timerLoop(2000, this, this.freshFingerFocus);
        }
        freshFingerFocus() {
            let curList = this.list[Math.floor(Math.random() * this.list.length)];
            this.owner.addChild(this.guideFinger);
            if (curList instanceof Laya.List) {

                let index = Math.floor(Math.random() * 6 + curList.startIndex);
                index = Math.min(curList.length - 1, index);
                var element = curList.getCell(index);
                this.updateFocus(element);

            }
        }


        updateFocus(comp) {
            if (comp == null || this.guideFinger == null) {
                return;
            }
            this.guideFinger.visible = true;
            this.localPoint.x = comp.width * 0.5;
            this.localPoint.y = comp.height * 0.5;
            comp.localToGlobal(this.localPoint, false, this.owner);
            this.guideFinger.pos(this.localPoint.x, this.localPoint.y);
            this.guideFinger.ef_finger.stop();
            this.guideFinger.ef_finger.play(0, true);
        }

    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportFullRank", ExportFullRank);

    class ExportScrollNone extends Laya.Script {
        constructor() {
            super();
            this.adList = null;// AdList;
        }

        initView(data) {
            this.adList = this.owner.getChildByName("adList").addComponent(AdList);
            this.adList.requestAdData(data.adType, false, AdList.SCROLL_NONE, data.iosFilterAppIds, 9, AdList.RandomSelect, data.isClockPendulum);
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportScrollNone", ExportScrollNone);

    class ExportShakeScrollNone extends Laya.Script {
        constructor() {
            super();
            this.adList = null;// AdList;
            this.list = null;// AdList;
            this.delayAnimTime = 3000;
            this.animIntervalTime = 500;
            this.data = null;
        }

        initView(data) {
            this.data = data;
            this.adList = this.owner.getChildByName("adList").addComponent(AdList);
            this.adList.requestAdData(data.adType, false, AdList.SCROLL_NONE, data.iosFilterAppIds, 6, AdList.RandomSelect, data.isClockPendulum);
            this.list = this.owner.getChildByName("adList");
            if (this.list instanceof Laya.List) {
                var num = this.list.length;
                for (var index = 0; index < num; index++) {
                    var element = this.list.getCell(index);
                    if (element == null) {
                        continue ;
                    }
                    element.addComponent(ShakeIcon);
                }
            }

            this.owner.timerLoop(this.delayAnimTime + this.animIntervalTime, this, this.freshAdItems);

        }

        freshAdItems() {
            if (this.list instanceof Laya.List) {
                var num = this.list.length;
                for (var index = 0; index < num; index++) {
                    var element = this.list.getCell(index);
                    var gameIcon = element.getComponent(ShakeIcon);
                    if (gameIcon == null) {
                        continue ;
                    }
                    gameIcon.playShakeAnim();
                }
                Laya.Tween.to(this.owner, {}, this.animIntervalTime, Laya.Ease.linearNone, Laya.Handler.create(this, function () {
                    this.adList.requestAdData(this.data.adType, false, AdList.SCROLL_NONE, this.data.iosFilterAppIds, 9, AdList.RandomSelect, this.data.isClockPendulum);
                }));
            }

        }

        onDisable() {
            this.owner.clearTimer(this, this.freshAdItems);
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportShakeScrollNone", ExportShakeScrollNone);

    class ShakeIcon extends Laya.Script {

        constructor() {
            super();
            this.animIntervalTime = 250;
            this.rotOffset = 5;
        }
        onAwake() {
            this.owner.rotation = 0;
        }

        playShakeAnim() {
            Laya.Tween.clearAll(this.owner);
            this.owner.rotation = 0;

            Laya.Tween.to(this.owner, { rotation: this.rotOffset }, this.animIntervalTime, Laya.Ease.linearNone, Laya.Handler.create(this, function () {
                Laya.Tween.to(this.owner, { rotation: 0 }, this.animIntervalTime, Laya.Ease.linearNone, null);
            }));
        }

    }
    Laya.ClassUtils.regClass("fc.ad.export.ShakeIcon", ShakeIcon);

    class ShakeExportIcon extends Laya.Script {

        constructor() {
            super();
            this.delayAnimTime = 1000;
            this.animIntervalTime = 3000;
            this.animDuaration = 1000;
            this.adIdx = 0;
            this.rotOffset = 10;
            this.currentAdData = null;
            this.adDataArr = null;
            this.maxNum = 4;
            this.animTime = 0;
            this.adType = 0;
        }

        initAd(adArr, adType) {
            this.adType = adType;
            this.adDataArr = adArr;
            this.adIdx %= adArr.length;
            this.onItemRender(adArr[this.adIdx]);
        }

        freshAdItems() {
            this.adIdx += this.maxNum;
            this.adIdx %= this.adDataArr.length;
            this.onItemRender(this.adDataArr[this.adIdx]);
        }

        onItemRender(adData) {
            if (adData == null) {
                if (this.currentAdData == null) {
                    this.owner.visible = false;
                }
                return;
            }
            this.currentAdData = adData;
            this.owner.visible = true;
            var item = this.owner;

            var icon = item.getChildByName("icon");
            if (icon) {
                icon.loadImage(adData.app_icon, null);
            }
            var name = item.getChildByName("name");
            if (name) {
                name.text = adData.app_title;
            }
            var desc = item.getChildByName("desc");
            if (desc) {
                desc.text = adData.app_desc;
            }
        }

        onClick() {
            if (this.currentAdData == null) {
                return;
            }
            var data = this.currentAdData;
            var self = this;
            self.isDataUpdate = true;
            data.fcAdType = this.adType;
            fc.ad.export.navigate2Mini(data,
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_SUCCESS, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_CANCEL, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_COMPLETED, data);
                }, [data]));
        }

        onStart() {
        }
        
        onUpdate() {
            if (this.animIntervalTime > 0) {
                this.animIntervalTime -= Laya.timer.delta;
                if (this.animIntervalTime <= 0) {
                    this.animDuaration = 1000;
                    this.freshAdItems();
                }
            }
            else if (this.animDuaration > 0) {
                this.animDuaration -= Laya.timer.delta;
                if (this.animDuaration <= 0) {
                    this.animIntervalTime = 3000;
                }
                this.animTime += Laya.timer.delta;
                this.owner.rotation = Math.sin(this.animTime / 200 * Math.PI) * 20;
            }
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ShakeExportIcon", ShakeExportIcon);

    class ShakeExportBox extends Laya.Script {
        constructor() {
            super();
            this.adType = 0;
            this.iconScriptArr = [];
        }

        initView(data) {
            this.adType = data.adType;
            var num = this.owner.numChildren;
            for (var index = 0; index < num; index++) {
                var element = this.owner.getChildAt(index);
                var gameIcon = element.addComponent(ShakeExportIcon);
                gameIcon.adIdx = index;
                gameIcon.maxNum = num;
                this.iconScriptArr.push(gameIcon);
            }
            this.requestAdData();
        }

        requestAdData() {
            var self = this;
            exports.loadAd(function (data) {
                var adData = data;
                for (var index = 0; index < self.iconScriptArr.length; index++) {
                    var gameIcon = self.iconScriptArr[index];
                    gameIcon.initAd(adData, self.adType);
                }
            },this.adType);
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ShakeExportBox", ShakeExportBox);

    class ExportLeftPop extends Laya.Script {
        constructor() {
            super();
            this.srcX = 0;
            this.adList = null;// AdList;
            this.adCheckBox = null;// Laya.Image;
        }

        initView(data) {
            this.srcX = this.owner.x;
            this.adList = this.owner.getChildByName("adList").addComponent(AdList);
            this.adCheckBox = this.owner.getChildByName("adCheckBox");
            this.adCheckBox.on(Laya.Event.CLICK, this, this.updateFloatPos);
            this.adList.requestAdData(data.adType, true, AdList.SCROLL_VERTICAL, data.iosFilterAppIds);
        }

        onDestroy() {
            this.adCheckBox.off(Laya.Event.CLICK, this, this.updateFloatPos);
        }

        updateFloatPos() {
            this.adCheckBox.mouseEnabled = false;
            if (this.adCheckBox.selected) {
                Laya.Tween.to(this.owner, { x: 0 }, 500, null, Laya.Handler.create(this, this.onTweenCompleted));
            }
            else {
                Laya.Tween.to(this.owner, { x: this.srcX }, 500, null, Laya.Handler.create(this, this.onTweenCompleted));
            }
        }

        onTweenCompleted() {
            this.adCheckBox.mouseEnabled = true;
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportLeftPop", ExportLeftPop);

    class ExportLeftPopShowed extends ExportLeftPop {
        constructor() {
            super();
        }

        onStart() {
            this.adCheckBox.selected = true;
            this.adCheckBox.mouseEnabled = false;
            Laya.Tween.to(this.owner, { x: 0 }, 500, null, Laya.Handler.create(this, this.onTweenCompleted));
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportLeftPopShowed", ExportLeftPopShowed);

    class ExportRightPop extends Laya.Script {
        constructor() {
            super();
            this.adFrame = null;
            this.adList = null;
        }

        initView(data) {
            this.adFrame = this.owner.getChildByName("adFrame")
            this.adList = this.owner.getChildByName("adList").addComponent(AdList2);
            this.adList.requestAdData(data.adType, false, AdList.SCROLL_NONE, data.iosFilterAppIds, 9);
            this.adList.owner.on(Event.UI_SWITCH_HIDE, this, this.onAdHide);
            this.adList.owner.on(Event.UI_SWITCH_SHOW, this, this.onAdShow);
        }

        onAdHide() {
            this.adList.owner.mouseEnabled = false;
            Laya.Tween.to(this.owner, { x: -150 }, 500, null, Laya.Handler.create(this, this.onTweenCompleted));
        }

        onAdShow() {
            this.adList.owner.mouseEnabled = false;
            Laya.Tween.to(this.owner, { x: -450 }, 500, null, Laya.Handler.create(this, this.onTweenCompleted));
        }

        onTweenCompleted() {
            this.adList.owner.mouseEnabled = true;
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportRightPop", ExportRightPop);

    class ExportLeftFlyBox extends Laya.Script {
        constructor() {
            super();
            this.isClick = false;
            this.adType = 0;
            this.adData = [];
            this.unData = [];
            this.showNum = 0;
            this.iosFilterAppIds = [];
        }

        initView(data) {
            this.adType = data.adType;
            this.showNum = this.owner.numChildren;
            this.iosFilterAppIds = data.iosFilterAppIds ? data.iosFilterAppIds : [];
            var self = this;
            for (var i = 0; i < this.showNum; i++) {
                var box = this.owner.getChildByName("ad_" + i);
                if (box) {
                    //播放动画
                    Laya.Tween.from(box, { rotation: 360, x: box.x - 500 }, 700, null, Laya.Handler.create(this, function () {
                        self.isClick = true;
                    }));
                }
            }
            exports.loadAd(function (data) {
                self.adData = data;
                self.freshAdBox();
            }, this.adType);
        }

        freshAdBox() {
            var self = this;
            this.adData = this.adData.filter(function (elment) {
                return Laya.Browser.onAndroid || self.iosFilterAppIds.indexOf(elment.appid) == -1;
            })
            //随机选取6个数据
            if (this.adData.length < this.showNum) {
                while (this.adData.length < this.showNum) {
                    this.adData.push(this.adData[Math.floor(Math.random() * this.adData.length)]);
                }
            }
            else if (this.adData.length > this.showNum) {
                while (this.adData.length > this.showNum) {
                    var data = this.adData.splice(Math.floor(Math.random() * this.adData.length), 1);
                    this.unData.push(data[0]);
                }
            }
            for (var i = 0; i < this.showNum; i++) {
                var adItemData = this.adData[i];
                if (!adItemData) {
                    continue;
                }
                var box = this.owner.getChildByName("ad_" + i);
                if (box) {
                    var icon = box.getChildByName("icon");
                    if (icon) {
                        icon.loadImage(adItemData.app_icon, null);
                    }

                    var name = box.getChildByName("name");
                    if (name) {
                        name.text = adItemData.app_title;
                    }

                    var titleBg = box.getChildByName("titleBg");
                    if (titleBg) {
                        titleBg.index = Math.floor(titleBg.clipY * Math.random());
                    }
                    var tag = box.getChildByName("tag");
                    if (tag) {
                        if (i < 2) {
                            tag.visible = true;
                            tag.index = Math.floor(tag.clipY * Math.random());
                        }
                        else {
                            tag.visible = false;
                        }
                    }

                    box.on(Laya.Event.CLICK, this, this.onBoxClick, [i]);
                }
            }
        }

        onBoxClick(i) {
            if (!this.isClick) return;
            var data = this.adData[i];
            var self = this;
            data.fcAdType = this.adType;
            fc.ad.export.navigate2Mini(data,
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_SUCCESS, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_CANCEL, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_COMPLETED, data);
                }, [data]));
            //更换该位置的数据
            if (this.unData.length > 0) {
                var data = this.unData.splice(Math.floor(Math.random() * this.unData.length), 1);
                this.unData.push((this.adData.splice(i, 1, data[0]))[0]);
                var box = this.owner.getChildByName("ad_" + i);
                var adItemData = this.adData[i];
                if (!adItemData) {
                    return;
                }
                if (box) {
                    var icon = box.getChildByName("icon");
                    if (icon) {
                        icon.loadImage(adItemData.app_icon, null);
                    }

                    var name = box.getChildByName("name");
                    if (name) {
                        name.text = adItemData.app_title;
                    }

                    var titleBg = box.getChildByName("titleBg");
                    if (titleBg) {
                        titleBg.index = Math.floor(titleBg.clipY * Math.random());
                    }
                    var tag = box.getChildByName("tag");
                    if (tag) {
                        if (i < 2) {
                            tag.visible = true;
                            tag.index = Math.floor(tag.clipY * Math.random());
                        }
                        else {
                            tag.visible = false;
                        }
                    }
                }
            }
        }
    }
    Laya.ClassUtils.regClass("fc.ad.export.ExportLeftFlyBox", ExportLeftFlyBox);

    class InviteBox extends Laya.Script {
        constructor() {
            super();
            this.lab_name = null;
            this.lab_invite = null;
            this.img_bg = null;
            this.adData = null;
            this.data = null;
            this.adType = 0;
            this.loopTime = 30000;
            this.y = fc.framework.Device.statusBarHeight * Laya.stage.height / fc.framework.Device.screenHeight;
        }
        onAwake() {
            this.owner.visible = false;
        }

        initView(data) {
            var self = this;
            this.owner.visible = false;
            this.owner.centerX = 0;
            this.owner.y = - this.owner.height;
            this.adType = data.adType;

            this.lab_name = this.owner.getChildByName("lab_name");
            this.lab_invite = this.owner.getChildByName("lab_invite");
            this.img_bg = this.owner.getChildByName("img_bg");

            exports.loadAd(function (data) {
                self.adData = data;
                self.initUI();
            }, this.adType);
        }

        initUI() {
            this.img_bg.on(Laya.Event.CLICK, this, this.onBgClick);
            this.owner.clearTimer(this, this.freshAdBox);
            this.owner.timerOnce(this.loopTime, this, this.freshAdBox);

        }

        delayHideBox() {
            Laya.Tween.clearAll(this.owner);
            Laya.Tween.to(this.owner, {}, 3000, null, Laya.Handler.create(this, function () {
                Laya.Tween.to(this.owner, { y: -this.owner.height }, 500);
                this.owner.clearTimer(this, this.freshAdBox);
                this.owner.timerOnce(this.loopTime, this, this.freshAdBox);
            }));
        }

        freshAdBox() {
            Laya.Tween.clearAll(this.owner);
            this.owner.visible = true;
            this.data = this.adData[Math.floor(Math.random() * this.adData.length)];
            this.lab_name.text = GameFrame.nicknameList[Math.floor(Math.random() * GameFrame.nicknameList.length)].nickname;
            this.lab_invite.text = "邀请您一起玩 " + this.data.app_title;

            fc.framework.Audio.playSound(GameFrame.appInfo.chatClick);
            fc.framework.Device.vibrateShort();
            Laya.Tween.to(this.owner, { y: this.y }, 500,null,Laya.Handler.create(this, function (){
                this.delayHideBox();
            }));
        }


        onBgClick() {
            let data = this.data;
            data.fcAdType = this.adType;
            fc.ad.export.navigate2Mini(data,
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_SUCCESS, data);
                }, [data]),
                Laya.Handler.create(this, function () {
                    fc.framework.GameFrame.openView(fc.view.ViewId.AdHome2, null, null);
                }, [data]),
                Laya.Handler.create(this, function () {
                    Laya.stage.event(Event.APP_JUMP_COMPLETED, data);
                }, [data]));

            Laya.Tween.clearAll(this.owner);
            Laya.Tween.to(this.owner, { y: -this.owner.height }, 500);
            this.owner.clearTimer(this, this.freshAdBox);
            this.owner.timerOnce(this.loopTime, this, this.freshAdBox);
        }

        onDisable() {
            Laya.Tween.to(this.owner, { y: -this.owner.height }, 500);
            this.owner.clearTimer(this, this.freshAdBox);
        }

    }
    Laya.ClassUtils.regClass("fc.ad.export.InviteBox", InviteBox);

    exports.AdList = AdList;
}(window.fc.ad.export, Laya))
