window.fc = window.fc || {};
window.fc.define = window.fc.define || {};
(function (exports, Laya) {
    'use strict';
    class Event {
    }
    Event.LOADING_PROGRESS = "LOADING_PROGRESS";
    Event.XHR_RESPONSE = "XHR_RESPONSE";
    Event.APP_JUMP_CANCEL = "NAVIGATE_FAILED"; //跳转失败
    Event.APP_JUMP_SUCCESS = "NAVIGATE_SUCCESS";//跳转成功
    Event.APP_JUMP_COMPLETED = "NAVIGATE_COMPLETED"
    Event.AD_CONFIIG_LOADED = "AD_CONFIIG_LOADED";
    Event.UI_TOAST_MESSAGE = "UI_TOAST_MESSAGE";
    Event.UI_PROGRESS_UPDATE = "UI_PROGRESS_UPDATE";
    Event.UI_SWITCH_SHOW = "UI_SWITCH_SHOW";
    Event.UI_SWITCH_HIDE = "UI_SWITCH_HIDE";
    Event.UI_VIEW_CLOSED = "UI_VIEW_CLOSED";
    Event.UI_VIEW_OPENED = "UI_VIEW_OPENED";
    Event.UI_SCENE_LOADED = "UI_SCENE_LOADED";
    Event.UI_SCENE_UNLOADED = "UI_SCENE_UNLOADED";
    Event.UI_LOADING_COMPLETED = "UI_LOADING_COMPLETED";
    Event.UI_GROUP_VIEW_LOADED = "UI_GROUP_VIEW_LOADED";
    Event.UI_GROUP_VIEW_UNLOADED = "UI_GROUP_VIEW_UNLOADED";
    Event.AD_VIDEO_PLAY = "EVENT_AD_VIDEO_PLAY";
    Event.AD_VIDEO_CLOSED = "EVENT_AD_VIDEO_CLOSED";
    Event.DEVICE_HIDE = "DEVICE_ON_HIDE";
    Event.DEVICE_SHOW = "DEVICE_ON_SHOW";
    Event.DEVICE_RESUME = "DEVICE_ON_RESUME";
    Event.JOYSTICK_KEY_PRESS = "JOYSTICK_KEY_PRESS";
    Event.JOYSTICK_KEY_DOWN = "JOYSTICK_KEY_DOWN";
    Event.JOYSTICK_KEY_UP = "JOYSTICK_KEY_UP";
    Event.JOYSTICK_FOCUS_ON = "JOYSTICK_FOCUS_ON";
    Event.APP_CONFIG_READY = "APP_CONFIG_READY";
    Event.LAUNCH_COMPLETED = "LAUNCH_COMPLETED";
    Event.DATA_SETTING_UPDATE = "DATA_SETTING_UPDATE";
    Event.DATA_LOGIN_INFO_UPDATE = "DATA_LOGIN_INFO_UPDATE";
    Event.GAME_SLEEP = "GAME_SLEEP";
    Event.GAME_WAKEUP = "GAME_WAKEUP";
    Event.GAME_HOME = "GAME_HOME";
    Event.GAME_PREPARE = "GAME_PREPARE";
    Event.GAME_START = "GAME_START";
    Event.GAME_BACK_HOME = "GAME_BACK_HOME";
    Event.GAME_SHOW = "GAME_SHOW";
    Event.GAME_SHOW_WIN = "GAME_SHOW_WIN";//"GAME_SHOW_WIN";
    Event.GAME_SHOW_FAIL = "GAME_SHOW_FAIL"; //"GAME_SHOW_FAIL";
    Event.GAME_WIN = "GAME_WIN";
    Event.GAME_FAILED = "GAME_FAILED";
    Event.GAME_RELIVE = "GAME_RELIVE";
    Event.GAME_OVER = "GAME_OVER";
    Event.GAME_NEXTRES_COM = "GAME_NEXTRES_COM";
    Event.EGG_GET_AWARD = "EGG_GET_AWARD";
    Event.GAME_RESET = "GAME_RESET";//重置游戏重新开始
    Event.GAME_RELIVE_START = "GAME_RELIVE_START";//复活游戏重新开始
    Event.STORE_UPDATE = "STORE_UPDATE"; //商城更新
    Event.STORE_SWITCH_TAB = "STORE_SWITCH_TAB";//商城切换tab选项卡
    Event.STORE_UNLOCK_ITEM = "STORE_UNLOCK_ITEM"; //道具解锁
    Event.STORE_USE_ITEM = "STORE_USE_ITEM";// 使用道具
    Event.STORE_PREVIEW = "STORE_PREVIEW";
    Event.GOLD_UPDATE = "GOLD_UPDATE"; //金币更新
    Event.VIP_UPDATE = "VIP_UPDATE";
    Event.SCORE_UPDATE = "SCORE_UPDATE";
    Event.STRENGTH_UPDATE = "STRENGTH_UPDATE"; //体力更新
    Event.LEVEL_PROGRESS_UPDATE = "LEVEL_PROGRESS_UPDATE";
    Event.CHANGE_CUR_MODEL = "CHANGE_CUR_MODEL"; // 玩家模型更改
    Event.KNOCK_COMPLETED = "KNOCK_COMPLETED";
    Event.TEXTURE_CAMERA_INIT = "TEXTURE_CAMERA_INIT";
    Event.TEXTURE_CAMERA_CLEAR = "TEXTURE_CAMERA_CLEAR";
    Event.GAMEPAD_DIRECTION_UPDATE = "GAMEPAD_DIRECTION_UPDATE";
    Event.JUMP_AWARD_IN_NATIVEAD = "JUMP_AWARD_IN_NATIVEAD";//点击跳过领取奖励后有概率进入原生广告
    Event.HIDE_NATIVEBANNER = "HIDE_NATIVEBANNER";//隐藏原生banner
    Event.SHOW_NATIVEBANNER = "SHOW_NATIVEBANNER";//恢复原生banner
    Event.CHOOSE_SKILLED = "CHOOSE_SKILLED";//选择了技能
    
    class SceneId {
    }
    SceneId.Loading = "loading";
    SceneId.Home = "home";
    SceneId.Prepare = "prepare";
    SceneId.Game = "game";
    SceneId.ShowSuccess = "showSuccess";
    SceneId.ShowFailed = "showFailed";
    SceneId.Success = "success";
    SceneId.Failed = "failed";
    SceneId.Over = "over";

    class JoystickCode {
    }
    JoystickCode.ESCAPE = 0x10;
    JoystickCode.OK = 0x1000;
    JoystickCode.UP = 0x1;
    JoystickCode.DOWN = 0x2;
    JoystickCode.LEFT = 0x4;
    JoystickCode.RIGHT = 0x8;
    JoystickCode.UNDEFINE = 0x8000;
        
    var Layout;
    (function (Layout) {
        Layout[Layout["VERTICAL_TOP"] = 0] = "VERTICAL_TOP";
        Layout[Layout["VERTICAL_MIDDLE"] = 1] = "VERTICAL_MIDDLE";
        Layout[Layout["VERTICAL_BOTTOM"] = 2] = "VERTICAL_BOTTOM";
        Layout[Layout["HORIZONTAL_LEFT"] = 4] = "HORIZONTAL_LEFT";
        Layout[Layout["HORIZONTAL_CENTER"] = 8] = "HORIZONTAL_CENTER";
        Layout[Layout["HORIZONTAL_RIGHT"] = 16] = "HORIZONTAL_RIGHT";
    })(Layout || (Layout = {}));

        
    var LoadingStep;
    (function (LoadingStep) {
        LoadingStep[LoadingStep["LOAD_SUBPACKAGE"] = 0] = "LOAD_SUBPACKAGE";
        LoadingStep[LoadingStep["LOAD_CONFIG"] = 1] = "LOAD_CONFIG";
        LoadingStep[LoadingStep["LOAD_3DRES"] = 2] = "LOAD_3DRES";
        LoadingStep[LoadingStep["LOAD_3DSCENE"] = 3] = "LOAD_3DSCENE";
        LoadingStep[LoadingStep["TOTAL_STEPS"] = 4] = "TOTAL_STEPS"
    })(LoadingStep || (LoadingStep = {}));

    exports.Event = Event;
    exports.Layout = Layout;
    exports.SceneId = SceneId;
    exports.JoystickCode = JoystickCode;
    exports.LoadingStep = LoadingStep;

}(window.fc.define, Laya))

